<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Transaction_model extends CI_Model
{
	function insert($sequence_no){
		$result=array();
		$error = 0;
		extract($_POST);
		$current_date = date('Y-m-d');
		$transaction_date=date('Y-m-d',strtotime(str_replace('/','-',$transaction_date)));

		/*Recalculate warning*/
		$recall_res = $this->db->query(" SELECT transaction_id, currency_id FROM `fc_deleted_transaction` WHERE txn_order=0 AND recalculated=0 AND currency_id!=1 AND currency_id='$currency_id' ");
		if($recall_res->num_rows()>0){ 
			++$error;
			$result['danger']='Please update the Stock Average Rate';
		}

		/* validation */
		$client_query = $this->db->query(" SELECT client_id FROM `fc_client_code` where 
			client_id='$client_id'  ");

		/* check token already exist. To prevent duplicate entry */
		$token_query = $this->db->query(" SELECT token FROM `fc_transaction` where token='$token' ");
		if( $token_query->num_rows() > 0 || $token == '' ){
			++$error;
			$result['danger']='Please try again !!!';
		}

		if( $client_query->num_rows() == 0 && $error == 0 ){
			$result['danger']='Please select the client';
			++$error;
		}

		if( ($client_id == '' && $error == 0) || $client_currency_id == '' ){
			$result['danger']='Please select the client';
			++$error;
		}

		if( $currency_id == '' && $error == 0 ){
			$result['danger']='Please select the currency';
			++$error;
		}

		if( $transaction_type == '' && $error == 0 ){
			$result['danger']='Please select the Txn Type';
			++$error;
		}

		$settle_close = $this->db->query(" SELECT transaction_date FROM `fc_transaction` WHERE `flag`=0 AND txn_type=2 AND transaction_date<'".$transaction_date."' AND currency_id !=1  ");
		
		if( $settle_close->num_rows() > 0 && $error == 0 ){
			$result['danger']='Permission Denied. Please Close The Lastday Settlement';
			++$error;
		}

		$eod_check = $this->db->query(" SELECT settlement_id FROM `fc_settlement` WHERE closing_date>='$transaction_date'  ");
		if( $eod_check->num_rows() > 0 && $error == 0 ){
			$result['danger']='Permission Denied. Settlement already closed in this date !!!';
			++$error;
		}

		// check month statement closed
		$month_close = $this->db->query(" SELECT id FROM `fc_settlement_month` WHERE month(month_year)='".date('m',strtotime($transaction_date))."' AND year(month_year)='".date('Y',strtotime($transaction_date))."' ");
		if( $month_close->num_rows() > 0 && $error == 0 ){
			$result['danger']='Month Settlement has been closed. You can not add transactions for the month of '.date('M-Y',strtotime($transaction_date));
			++$error;
		}
		


		$quantity = str_replace(",","",$quantity);
		$quantity = round($quantity,2);
		if( !is_numeric($quantity) && $error == 0 ){
			$result['danger']='Please Try Again !!!';
			++$error;
		}

		// get client currency rateunit
		$clcurunit = $this->db->query(" SELECT A.rate_unit FROM `fc_currency` A LEFT JOIN `fc_clients` B ON A.currency_id=B.currency_id WHERE B.client_id='$client_id'  ");
		$clcurunit_res = $clcurunit->row_array();
		$client_currency_rate_unit = $clcurunit_res['rate_unit'];

		// if currency MYR
		if( $client_currency_id == 1 ){
			$fc_rate=$fc_convert=$fc_total_rate=$fc_total_rate_acc=0;
			$rm_rate = str_replace(",","",$rm_rate);
			$rm_total_rate = str_replace(",","",$rm_total_rate);
		}
		// for other currency
		if( $client_currency_id != 1 ){
			$fc_rate = str_replace(",","",$fc_rate);
			$fc_convert = str_replace(",","",$fc_convert);
			$rm_rate = str_replace(",","",$rm_rate);
			$rm_total_rate = str_replace(",","",$rm_total_rate);
			$fc_total_rate = str_replace(",","",$fc_total_rate);
			$fc_total_rate_acc = $fc_total_rate;
		}

		if( ( !is_numeric($fc_total_rate) || !is_numeric($rm_total_rate) ) && $error == 0 ){
			$result['danger']='Please Try Again !!!';
			++$error;
		}

	// client accout
	$client_account_res01=$this->db->query(" SELECT * FROM `fc_client_account` where client_id=".$this->db->escape($client_id)." and currency_id=".$this->db->escape($client_currency_id)." ");
	$client_account_row01=$client_account_res01->row_array();

	// main account
	$main_account_res01=$this->db->query(" SELECT A.currency_id, B.stock_credit,B.stock_debit,B.credit_rm,B.debit_rm,A.rate_unit,B.avg_rate FROM `fc_currency` A LEFT JOIN `fc_main_account` B ON A.currency_id=B.currency_id where A.currency_id=".$this->db->escape($currency_id)." ");
	$main_account_row01=$main_account_res01->row_array();
	$stock_margin_value = ($main_account_row01['avg_rate']>0)?$main_account_row01['avg_rate']:0;	
	$is_first_debit = 0;
	if( $transaction_type == 2 && $main_account_row01['stock_credit'] == 0 && $main_account_row01['stock_debit'] >= 0 ){
		$is_first_debit = 1;
	}

	/*
		For first credit after 1st debit 
	*/
	$update_first_debit_stock_avg=$first_debit_transaction_id=0;
	$first_debit_array = array();
	if( $main_account_row01['stock_credit'] == 0 && $transaction_type == 1 && $main_account_row01['stock_debit'] > 0 ){
		$update_first_debit_stock_avg = 1;
	}

	/* Check currency stock is zero or not to update transaction group 
		Manage unique group id for set of txn until get tally
	*/
	$currency_available_stock = $this->db->query(" SELECT * FROM `fc_currency` WHERE currency_id=$currency_id AND stock_credit=stock_debit ");
	if($currency_available_stock->num_rows() > 0){
		$txn_group_query = $this->db->query(" INSERT INTO `fc_txn_group`(currency_id,title)VALUES('$currency_id','1') ");
		$txn_group = $this->db->insert_id();
	} else {
		$txn_group_query = $this->db->query(" SELECT * FROM `fc_txn_group` WHERE currency_id=$currency_id ORDER BY txn_group desc limit 1  ");
		$txn_group_result = $txn_group_query->row_array();
		$txn_group = $txn_group_result['txn_group'];
	}

	$txnno_query = $this->db->query(" SELECT transaction_id,txnno FROM `fc_transaction` WHERE currency_id='$currency_id' AND flag=0 AND txn_order=0 AND txn_group='$txn_group' ");
	$txnno_result = $txnno_query->row_array();
	$txnno = $txnno_query->num_rows();
	$txnno += $txnno_result['txnno'];

			if( !$result && $error==0 ){

				$data = array(
					'transaction_reference' => $sequence_no,
					'txn_group'				=> $txn_group,
					'txnno'					=> $txnno,
					'client_id'				=> $client_id,
					'transaction_date'		=> $transaction_date,
					'txn_type'				=> $transaction_type,
					'currency_id'			=> $currency_id,
					'currency_name'			=> $currency_code,
					'currency_descr'		=> $currency_descr,
					'currency_rate_unit'	=> $currency_rate_unit,
					'client_currency_rate_unit' => $client_currency_rate_unit,
					'quantity'				=> $quantity,
					'rm_rate'				=> $rm_rate,
					'rm_total_rate'			=> $rm_total_rate,
					'fc_rate'				=> $fc_rate,
					'fc_convert'			=> $fc_convert,
					'system_convert'		=> $system_convert,
					'fc_total_rate'			=> $fc_total_rate,
					'fc_total_rate_acc'		=> $fc_total_rate_acc,
					'created_at'			=> date('Y-m-d H:i:s'),
					'user_id'				=> $this->session->userdata('fcuser_id'),
					'before_fc_credit_c'	=> ($client_account_row01['fc_credit']>0)?$client_account_row01['fc_credit']:0,
					'before_fc_debit_c'		=> ($client_account_row01['fc_debit']>0)?$client_account_row01['fc_debit']:0,
					'before_rm_credit_c'	=> ($client_account_row01['rm_credit']>0)?$client_account_row01['rm_credit']:0,
					'before_rm_debit_c'		=> ($client_account_row01['rm_debit']>0)?$client_account_row01['rm_debit']:0,
					'before_stock_credit_m'	=> ($main_account_row01['stock_credit']>0)?$main_account_row01['stock_credit']:0,
					'before_stock_debit_m'	=> ($main_account_row01['stock_debit']>0)?$main_account_row01['stock_debit']:0,
					'before_credit_rm_m'	=> ($main_account_row01['credit_rm']>0)?
						$main_account_row01['credit_rm']:0,
					'before_debit_rm_m'		=> ($main_account_row01['debit_rm']>0)?$main_account_row01['debit_rm']:0,
					'stock_margin_value'    => $stock_margin_value,
					'token'					=> $token,
					'is_first_debit'		=>	$is_first_debit
				);

				$up = $this->db->insert("fc_transaction",$data);
				
				if($up){

                    $transaction_id=$this->db->insert_id();

                    // for sequence no generation
                    if($txn_reference == '') {
                    	$this->db->query(" INSERT INTO `fc_txn_sno` (`transaction_id`, `title`) VALUES ($transaction_id, 'A'); ");	
                    }
                    

					/* create account if not available otherwise update based client currency only*/
					$client_account_res = $this->db->query(" SELECT client_id FROM `fc_client_account` where client_id='$client_id' and currency_id='$client_currency_id' ");

					if( $client_account_res->num_rows() > 0 ){ // update

						/* credit method */
						if( $transaction_type == 1 ){
							$this->db->query(" update fc_client_account set 
									rm_credit=rm_credit+$rm_total_rate, 
									fc_credit=fc_credit+$fc_total_rate_acc
									where client_id='$client_id' and currency_id='$client_currency_id'
									");
						}

						// debit method
						if( $transaction_type == 2 ){
							$this->db->query(" update fc_client_account set 
									rm_debit=rm_debit+$rm_total_rate, 
									fc_debit=fc_debit+$fc_total_rate_acc
									where client_id='$client_id' and currency_id='$client_currency_id'
									");	
						}

					} else { // create

						/* credit method */
						if( $transaction_type == 1 ){
							$this->db->query(" insert into fc_client_account set 
										rm_credit=$rm_total_rate, 
										fc_credit=$fc_total_rate_acc,
										client_id='$client_id', 
										currency_id='$client_currency_id'
									");
						}

						// debit method
						if( $transaction_type == 2 ){
							$this->db->query(" insert into fc_client_account set 
										rm_debit=$rm_total_rate, 
										fc_debit=$fc_total_rate_acc,
										client_id='$client_id', 
										currency_id='$client_currency_id'
									");
						}

					}

					// main account based on currency i.e choosen while txn
					$main_account_res = $this->db->query(" SELECT currency_id FROM `fc_main_account` where currency_id='$currency_id' ");

					if( $main_account_res->num_rows() > 0 ){ // update
						
						/* credit method */
						if( $transaction_type == 1 ){
							$this->db->query(" update fc_main_account set 
									stock_credit=stock_credit+$quantity, 
									credit_rm=credit_rm+$rm_total_rate, 
									updated_at='".date('Y-m-d H:i:s')."'
							 		where currency_id='$currency_id' ");
						}

						// debit method
						if( $transaction_type == 2 ){
							$this->db->query(" update fc_main_account set 
									stock_debit=stock_debit+$quantity, 
									debit_rm=debit_rm+$rm_total_rate, 
									updated_at='".date('Y-m-d H:i:s')."'
							 		where currency_id='$currency_id' ");
						}
					
					} else { // create

						/* credit method */
						if( $transaction_type == 1 ){
							$this->db->query(" insert into fc_main_account set 
										stock_credit=$quantity, 
										credit_rm=$rm_total_rate,
										currency_id='$currency_id'
									");
						}

						// debit method
						if( $transaction_type == 2 ){
							$this->db->query(" insert into fc_main_account set 
										stock_debit=$quantity, 
										debit_rm=$rm_total_rate,
										currency_id='$currency_id'
									");
						}
					}

					/*START CURRENCY STOCK MAINTENANCE*/

					/* credit method */
					if( $transaction_type == 1 ){
						$this->db->query(" UPDATE fc_currency set 
								stock_credit=stock_credit+$quantity, 
								credit_rm=credit_rm+$rm_total_rate
								where currency_id='$currency_id' ");
					}

					/* debit method */
					if( $transaction_type == 2 ){
						$this->db->query(" UPDATE fc_currency set 
								stock_debit=stock_debit+$quantity, 
								debit_rm=debit_rm+$rm_total_rate
						 		where currency_id='$currency_id' ");
					}

					/*END CURRENCY STOCK MAINTENANCE*/

					// update currency avg rate
					 if( $currency_id > 1 ){ // calculate avg rate except MYR
					 // 	$this->update_currency_rate($currency_id, $transaction_type, $transaction_id,
						// $update_first_debit_stock_avg, $txn_group);

						$this->update_currency_rate($currency_id,$transaction_id,$txn_group);
						$this->currency_averate_rate($currency_id,$transaction_id,$txn_group);
					 }
					
					
					$result['transaction_id'] = $transaction_id;
					$result['success']='Data Added Successfully !!!';

				}else{
					$result['danger']='Sorry... Unable to insert the transaction !!!';
				}
			}
		
		return $result;
	}

	
	function delete($transaction_id){
		$error = 0;
		$txn_query = $this->db->query(" SELECT * FROM `fc_transaction` WHERE 
			transaction_id='$transaction_id'  ");
		$txn_res = $txn_query->row_array();

		$txn_date_1 = $txn_res['transaction_date'];
		$amount_array = array();
		$currency_id = $txn_res['currency_id'];
		$txn_type = $txn_res['txn_type'];
		$client_id = $txn_res['client_id'];
		$txn_flag = $txn_res['flag'];
		$txn_order = $txn_res['txn_order'];
		$txn_group = $txn_res['txn_group'];
		$quantity = $txn_res['quantity'];
		$total_credit_rm = $txn_res['rm_total_rate'];
		$amount_array = array(
							'currency_id'		=>	$txn_res['currency_id'],
							'quantity'			=>	$txn_res['quantity'],
							'fc_total_rate'		=>	$txn_res['fc_total_rate'],
							'fc_total_rate_acc'	=>	$txn_res['fc_total_rate_acc'],
							'rm_total_rate'		=>	$txn_res['rm_total_rate']
						);

		if( $txn_query->num_rows() == 0 ){ redirect('dashboard','refresh'); die(); }

		/* Disable Remove option after EOD */
		$eod_check = $this->db->query(" SELECT settlement_id FROM `fc_settlement` WHERE closing_date>='$txn_date_1'  ");
		if( $eod_check->num_rows() > 0 ){
			$result['danger']='Permission Denied. You can not remove once the transaction moved to settlement';
			++$error;
		}

		if( $txn_res['flag'] > 1  ){
			++$error;
			$result['danger']='Permission Denied. We can not remove this transition. Because this transaction may be from Order, Daily OR Month Settlement';
		}

		/* Check if txn is first credit after reset.... only for main txn */
		if( $txn_res['txn_order'] == 0 && $txn_res['txn_type'] == 1 && $currency_id != 1 && $txn_flag==0 ){

			$is_debit_txn = $this->db->query(" SELECT is_reset FROM `fc_transaction` WHERE  
				txn_order=0 AND currency_id='".$currency_id."' AND transaction_id > '$transaction_id' 
				AND txn_type=2 ");

			if( $is_debit_txn->num_rows() > 0 ){
				//++$error;
				//$result['danger']='Please delete the <b>Debit transactions first</b>';
			}

		}

		/* Check is there any first debit txn exist without any credit record. If exist, disable remove option for txn which are added before these first txn */
		$old_txn_res = $this->db->query(" SELECT transaction_id, is_first_debit FROM `fc_transaction` 
			WHERE txn_order=0 AND currency_id='".$currency_id."' AND transaction_id > '$transaction_id' 
				AND currency_id != 1 ORDER BY transaction_id DESC LIMIT 1 ");
		$old_txn_row = $old_txn_res->row_array();
		if( $old_txn_row['is_first_debit'] == 1 ){
				// ++$error;
				// $result['danger']='Please delete the <b>First Debit transactions</b> and then try again';
		}
		

		/*Recalculate warning*/
		$recall_res = $this->db->query(" SELECT transaction_id, currency_id FROM `fc_deleted_transaction` WHERE txn_order=0 AND recalculated=0 AND currency_id!=1 ");
		if($recall_res->num_rows()>0){ 
			++$error;
			$result['danger']='Please update the Stock Average Rate and Try Again !!!';
		}

		

		$settle_query = $this->db->query(" SELECT id FROM `fc_settlement_month` WHERE month(month_year)='".date('m',strtotime($txn_date_1))."' AND year(month_year)='".date('Y',strtotime($txn_date_1))."'  ");
		if( $settle_query->num_rows() > 0 ) {
			++$error;
			$result['danger']='Sorry. We can not remove this record. Bcz its moved to monthly settlement';
		}

		/* START CHECK STOCK IS AVAILABLE IN CURRENCY AND CLIENT ACCOUNT */
		if( $txn_type == 1 && $currency_id != 1 ){

			$cl_acc_amount_c = $this->db->query(" SELECT client_id FROM `fc_client_account` WHERE
			`client_id`='$client_id' AND fc_credit < '".$txn_res['fc_total_rate_acc']."' AND 
			rm_credit < '".$txn_res['rm_total_rate']."' ");

			$cr_acc_amount_c = $this->db->query(" SELECT currency_id FROM `fc_currency` WHERE currency_id='$currency_id' AND stock_credit < '".$txn_res['quantity']."' AND 
			    credit_rm < '".$txn_res['rm_total_rate']."' ");
	

			if( $cl_acc_amount_c->num_rows() > 0 || $cr_acc_amount_c->num_rows() > 0 )
			{
				++$error;
				$result['danger']='Permission Denied. There is no sufficient stock';
			}
		}

		if( $txn_type == 2 && $currency_id != 1 ){

			$cl_acc_amount_d = $this->db->query(" SELECT client_id FROM `fc_client_account` WHERE
			`client_id`='$client_id' AND fc_debit < '".$txn_res['fc_total_rate_acc']."' AND 
			rm_debit < '".$txn_res['rm_total_rate']."' ");

			$cr_acc_amount_d = $this->db->query(" SELECT currency_id FROM `fc_currency` WHERE currency_id='$currency_id' AND stock_debit < '".$txn_res['quantity']."' AND 
			    debit_rm < '".$txn_res['rm_total_rate']."' ");

			if( $cl_acc_amount_d->num_rows() > 0 || $cr_acc_amount_d->num_rows() > 0 )
			{
				++$error;
				$result['danger']='Permission Denied. There is no sufficient stock';
			}
		}
		/* END CHECK STOCK IS AVAILABLE IN CURRENCY AND CLIENT ACCOUNT */

		

	if( empty($result) && $error == 0 ){


		$query=$this->db->query(" delete FROM `fc_transaction` where 
				transaction_id='$transaction_id' ");
		if($query){
			// remove amount from currency & client account
			$this->client_account_deduction($txn_type,$client_id,$amount_array,$txn_flag,$txn_order);

		if($currency_id != 1){
			/*
				check any new group exist in this currency
			*/
			$group_txn = $this->db->query(" SELECT txn_group FROM `fc_transaction` WHERE currency_id='$currency_id' AND flag IN (0,1) AND txn_order=0 AND txn_group > '$txn_group' ");
			$group_exist = $group_txn->num_rows();
			$group_exist_row = $group_txn->row_array();

			/* CHECK BEFORE ANY TXN AFTER THIS GROUP AND RESET RECORD AVAIL */
			$check_txn = $this->db->query(" SELECT transaction_id,txn_group FROM fc_transaction WHERE txn_group =(SELECT txn_group FROM `fc_transaction` WHERE currency_id='$currency_id' AND flag IN (0,1) AND txn_order=0 AND txn_group > '$txn_group' ORDER BY txn_group DESC LIMIT 1) AND currency_id='$currency_id' AND flag=0 AND txn_order=0 AND is_reset=1 ");
			$check_txn_row = $check_txn->row_array();

			if($check_txn->num_rows() > 0 && $group_exist > 0){

				$utxn_group = $this->txn_group($currency_id);
				$this->db->query(" UPDATE fc_deleted_transaction SET updated_txn_group='$utxn_group' WHERE transaction_id='$transaction_id' ");

				$txnno = 1;
				$record_query = $this->db->query(" SELECT GROUP_CONCAT(transaction_id) AS ids FROM `fc_transaction` WHERE currency_id='$currency_id' AND flag IN (0,1) AND txn_order=0 AND txn_group='$txn_group' ORDER BY txnno ");
				$record_results = $record_query->row_array();
				$ids = explode(",",$record_results['ids']);
				for( $i=0;$i<count($ids);$i++ ){
					$this->db->query(" UPDATE fc_transaction SET txn_group='$utxn_group', txnno='$txnno' WHERE transaction_id='".$ids[$i]."' AND currency_id='$currency_id' AND flag IN (0,1) AND txn_order=0 AND transaction_id>0 ");
					++$txnno;
				}

			}elseif ($check_txn->num_rows() == 0 && $group_exist > 0){

				$check_txn = $this->db->query(" SELECT transaction_id,txn_group FROM fc_transaction WHERE txn_group =(SELECT txn_group FROM `fc_transaction` WHERE currency_id='$currency_id' AND flag IN (0,1) AND txn_order=0 AND txn_group > '$txn_group' ORDER BY txn_group DESC LIMIT 1) AND currency_id='$currency_id' AND flag=0 AND txn_order=0  ");
				$check_txn_row = $check_txn->row_array();

				$utxn_group = $check_txn_row['txn_group'];
				$this->db->query(" UPDATE fc_deleted_transaction SET updated_txn_group='$utxn_group' WHERE transaction_id='$transaction_id' ");

				/* count how many records exist in current group */
				$record_count = $this->db->query(" SELECT transaction_id FROM `fc_transaction` WHERE currency_id='$currency_id' AND flag=0 AND txn_order=0 AND txn_group='$utxn_group' ");

				$txnno = $record_count->num_rows()+1;
				$record_query = $this->db->query(" SELECT  GROUP_CONCAT(transaction_id) AS ids FROM `fc_transaction` WHERE currency_id='$currency_id' AND flag IN (0,1) AND txn_order=0 AND txn_group='$txn_group' ORDER BY txnno ");
				$record_results = $record_query->row_array();
				$ids = explode(",",$record_results['ids']);
				for( $i=0;$i<count($ids);$i++ ){

					$this->db->query(" UPDATE fc_transaction SET txn_group='$utxn_group', txnno='$txnno' WHERE transaction_id='".$ids[$i]."' AND currency_id='$currency_id' AND flag IN (0,1) AND txn_order=0 AND transaction_id>0 ");
					++$txnno;
				}

			}elseif ($group_exist == 0){


				$txnno = 1;
				$record_query = $this->db->query(" SELECT GROUP_CONCAT(transaction_id) AS ids FROM `fc_transaction` WHERE currency_id='$currency_id' AND flag IN (0,1) AND txn_order=0 AND txn_group='$txn_group' ORDER BY txnno ");
				$record_results = $record_query->row_array();
				$ids = explode(",",$record_results['ids']);
				for( $i=0;$i<count($ids);$i++ ){
					$this->db->query(" UPDATE fc_transaction SET txnno='$txnno' WHERE transaction_id='".$ids[$i]."' AND currency_id='$currency_id' AND flag IN (0,1) AND txn_order=0 AND transaction_id>0 ");
					++$txnno;
				}

				$this->db->query(" UPDATE fc_deleted_transaction SET updated_txn_group='$txn_group' WHERE transaction_id='$transaction_id' ");
			}
		}

			$result['success']='Transation removed successfully. Please Re-calculate the average rate';
		}else{
			$result['danger']='Sorry. Unable To Remove This Transaction !!!';
		}
	
	
	}

	return $result;

}


	// function record_list($sql=null){
	// 	$query=$this->db->query(" 
	// 		SELECT * FROM (SELECT `transaction_id`, `token`, `transaction_reference`, `client_id`, `transaction_date`, `txn_type`, `currency_id`, `currency_name`, `currency_descr`, `currency_rate_unit`, `client_currency_rate_unit`, `quantity`, `fc_rate`, `fc_convert`, `system_convert`, `fc_total_rate`, `rm_rate`, `rm_total_rate`, `before_fc_credit_c`, `before_fc_debit_c`, `before_rm_credit_c`, `before_rm_debit_c`, `before_stock_credit_m`, `before_stock_debit_m`, `before_credit_rm_m`, `before_debit_rm_m`, `stock_margin_value`, `created_at`, `updated_at`, `user_id`, `flag`, `mflag`, `txn_order`, `order_id`, `settlement_id`,'1' AS ttype,txn_group, is_reset, '0' AS stock_set,txnno FROM `fc_transaction` ) AS A WHERE 1 ".$sql." order by transaction_id DESC
	// 		");
	// 	return $query->result_array();
	// }

function record_list($sql=null){
		$query=$this->db->query(" 
			SELECT * FROM (SELECT `transaction_id`, `token`, `transaction_reference`, `client_id`, `transaction_date`, `txn_type`, `currency_id`, `currency_name`, `currency_descr`, `currency_rate_unit`, `client_currency_rate_unit`, `quantity`, `fc_rate`, `fc_convert`, `system_convert`, `fc_total_rate`, `rm_rate`, `rm_total_rate`, `before_fc_credit_c`, `before_fc_debit_c`, `before_rm_credit_c`, `before_rm_debit_c`, `before_stock_credit_m`, `before_stock_debit_m`, `before_credit_rm_m`, `before_debit_rm_m`, `stock_margin_value`, `created_at`, `updated_at`, `user_id`, `flag`, `mflag`, `txn_order`, `order_id`, `settlement_id`,'1' AS ttype,txn_group, is_reset, '0' AS stock_set FROM `fc_transaction`
			UNION
			SELECT `transaction_id`, `token`, `transaction_reference`, `client_id`, `transaction_date`, `txn_type`, `currency_id`, `currency_name`, `currency_descr`, `currency_rate_unit`, `client_currency_rate_unit`, `quantity`, `fc_rate`, `fc_convert`, `system_convert`, `fc_total_rate`, `rm_rate`, `rm_total_rate`, `before_fc_credit_c`, `before_fc_debit_c`, `before_rm_credit_c`, `before_rm_debit_c`, `before_stock_credit_m`, `before_stock_debit_m`, `before_credit_rm_m`, `before_debit_rm_m`, `stock_margin_value`, `created_at`, `updated_at`, `user_id`, `flag`, `mflag`, `txn_order`, `order_id`, `settlement_id`,'2' AS ttype,txn_group, is_reset, stock_set FROM `fc_deleted_transaction` ) AS A WHERE 1 ".$sql." order by transaction_id DESC
			");
		return $query->result_array();
	}

	function deleted_record($sql=null){
		$query=$this->db->query(" SELECT `transaction_id`, `token`, `transaction_reference`, `client_id`, `transaction_date`, `txn_type`, `currency_id`, `currency_name`, `currency_descr`, `currency_rate_unit`, `client_currency_rate_unit`, `quantity`, `fc_rate`, `fc_convert`, `system_convert`, `fc_total_rate`, `rm_rate`, `rm_total_rate`, `before_fc_credit_c`, `before_fc_debit_c`, `before_rm_credit_c`, `before_rm_debit_c`, `before_stock_credit_m`, `before_stock_debit_m`, `before_credit_rm_m`, `before_debit_rm_m`, `stock_margin_value`, `created_at`, `updated_at`, `user_id`, `flag`, `mflag`, `txn_order`, `order_id`, `settlement_id`,'1' AS ttype,txn_group, is_reset, '0' AS stock_set FROM `fc_deleted_transaction` WHERE 1 ".$sql." order by transaction_id DESC");
		return $query->result_array();
	}

	function show($transaction_id){
		$query=$this->db->query(" SELECT * FROM `fc_transaction` where transaction_id='$transaction_id' ");
		return $query->row_array();
	}



	function client_account_deduction($txn_type,$client_id,$amount_array,$flag,$txn_order){

		$client_query = $this->db->query(" SELECT currency_id FROM `fc_clients` 
		where client_id='$client_id'  ");
		$client_res = $client_query->row_array();
		$client_currency_id = $client_res['currency_id'];

		$fc_total_rate = $amount_array['fc_total_rate'];
		$fc_total_rate_acc = $amount_array['fc_total_rate_acc'];
		$rm_total_rate = $amount_array['rm_total_rate'];
		$quantity = $amount_array['quantity'];
		$currency_id = $amount_array['currency_id'];

		if( $txn_type ==1 ) { //credit

			/* client Account */
			$this->db->query(" UPDATE `fc_client_account` SET fc_credit=fc_credit-$fc_total_rate_acc,
			rm_credit=rm_credit-$rm_total_rate WHERE currency_id='$client_currency_id' 
			AND client_id='$client_id' ");

			if( ($flag == 0 || $flag == 1) && $txn_order == 0 ){
				/*CURRENCY STOCK*/
				$this->db->query(" UPDATE `fc_currency` SET stock_credit=stock_credit-$quantity,
				credit_rm=credit_rm-$rm_total_rate WHERE currency_id='$currency_id' ");

				$this->db->query(" UPDATE `fc_main_account` SET stock_credit=stock_credit-$quantity,
				credit_rm=credit_rm-$rm_total_rate WHERE currency_id='$currency_id' ");
			}

		}

		if( $txn_type ==2 ) { //debit

			/* client Account */
			$this->db->query(" UPDATE `fc_client_account` SET fc_debit=fc_debit-$fc_total_rate_acc,
			rm_debit=rm_debit-$rm_total_rate WHERE currency_id='$client_currency_id' AND client_id='$client_id' ");

			if( ($flag == 0 || $flag == 1) && $txn_order == 0 ){
				/*CURRENCY STOCK*/
				$this->db->query(" UPDATE `fc_currency` SET stock_debit=stock_debit-$quantity,
				debit_rm=debit_rm-$rm_total_rate WHERE currency_id='$currency_id' ");

				$this->db->query(" UPDATE `fc_main_account` SET stock_debit=stock_debit-$quantity,
				debit_rm=debit_rm-$rm_total_rate WHERE currency_id='$currency_id' ");
			}

		}

	}
	

	function currency_averate_rate($currency_id,$transaction_id,$txn_group){

		$query = $this->db->query(" SELECT txn_type,quantity FROM `fc_transaction` WHERE 
		currency_id=$currency_id AND txn_group=$txn_group ORDER BY txnno ASC ");
		$total_credit_stock = $total_debit_stock = 0;
		$enable_case1 = 0;
		$counter = 1; 
		$total_rows = $query->num_rows();
		foreach ($query->result_array() as $value) {

			if($value['txn_type'] == 1){ //Credit
				$total_credit_stock += $value['quantity'];
			}

			if($value['txn_type'] == 2){ //Debit
				$total_debit_stock += $value['quantity'];
			}

			if($total_credit_stock < $total_debit_stock){
				$this->averate_rate_calculate_type_2($currency_id,$transaction_id,$txn_group);
				break;
			}

			if( $total_rows == $counter ){
				if($total_credit_stock < $total_debit_stock){
					$this->averate_rate_calculate_type_2($currency_id,$transaction_id,$txn_group);
				}

				if($total_credit_stock >= $total_debit_stock){
					$this->averate_rate_calculate_type_1($currency_id,$transaction_id,$txn_group);
				}
			}

			++$counter;
		}

	}

	/*
		---------------- CASE 1 -----------	
		Currency Average rate calculation based Credit-Debit
		This case occur When C >= D ie if no negative stock occur in this whole txn group
		C=1000 R=1.5 V=1500    AVG=1.5   S     RM    AVG
										 1000  1500  1.5

		D=500  R=2   V=1000              500   750   1.5
		Here deduct RM Value based original rm rate ie1.5 not 2
	*/
	function averate_rate_calculate_type_1($currency_id,$transaction_id,$txn_group){
		
		$query = $this->db->query(" SELECT txn_type,quantity,rm_total_rate,rm_rate,transaction_id FROM `fc_transaction` WHERE 
		currency_id=$currency_id AND txn_group=$txn_group ORDER BY txnno ASC ");
		$total_stock=$total_rm=0;
		$total_rows = $query->num_rows();

		$currency_query = $this->db->query(" SELECT rate_unit FROM `fc_currency` WHERE currency_id=$currency_id ");
		$currency_result = $currency_query->row_array();
		$currency_rate_unit = $currency_result['rate_unit'];
		$currency_avg_rate = 0;
		foreach ($query->result_array() as $value) {

			if($value['txn_type'] == 1){ //Credit
				$total_stock += $value['quantity'];
				$total_rm += $value['rm_total_rate'];
				if( $currency_avg_rate == 0 ){
					$currency_avg_rate = $total_rm/$total_stock;
					$currency_avg_rate = abs($currency_avg_rate*$currency_rate_unit);
				}
			}

			if($value['txn_type'] == 2){ //Debit
				$total_stock -= $value['quantity'];
				$original_rm_value = ($value['quantity']*$currency_avg_rate);
				$original_rm_value = round(($original_rm_value/$currency_rate_unit),2);
				$total_rm -= $original_rm_value;

				// echo $total_rm."=";
				// echo "<br>";
				// echo $currency_avg_rate."=";
				// echo "<br>";
				// echo $total_stock;
			}

			if( $total_stock > 0 ){
				$currency_avg_rate = $total_rm/$total_stock;
				$currency_avg_rate = abs($currency_avg_rate*$currency_rate_unit);
			}

			$query=$this->db->query(" UPDATE `fc_transaction` SET stock_margin_value_1='$currency_avg_rate' WHERE transaction_id='".$value['transaction_id']."' AND flag=0 AND txn_order=0 AND txn_type=2 ");

			$this->db->query(" UPDATE `fc_currency` set currency_avg_rate=$currency_avg_rate 
			where currency_id=".$currency_id." ");

			$this->db->query(" update `fc_main_account` set avg_rate=$currency_avg_rate 
			where currency_id=".$currency_id." ");
		}
	}




	/*
	 -------------------- CASE 2 ---------------
	 Curreny Average rate calculation based on only Credits txn
	 This case occur when credit stock is lesser than debit tx ( C < D ) ie negative value occur in any single txn of this group
	 Apply this method if C < D occur in any stage of txn group
	*/
	function averate_rate_calculate_type_2($currency_id,$transaction_id,$txn_group){

		$query = $this->db->query(" SELECT SUM(quantity) AS quantity, SUM(rm_total_rate) AS rm_total_rate FROM `fc_transaction` WHERE currency_id='$currency_id' AND txn_order=0 AND 
			txn_group='$txn_group' AND txn_type=1 ");
		$result = $query->row_array();
		$credit_rows = $query->num_rows();

		$currency_query = $this->db->query(" SELECT rate_unit,currency_avg_rate FROM `fc_currency` WHERE currency_id=$currency_id ");
		$currency_result = $currency_query->row_array();
		
		if($credit_rows > 0 && $result['quantity'] > 0){
			$currency_avg_rate = $result['rm_total_rate']/$result['quantity'];
			$currency_avg_rate = abs($currency_avg_rate*$currency_result['rate_unit']);
		}else{
			$currency_avg_rate = $currency_result['currency_avg_rate'];
		}

		$query=$this->db->query(" UPDATE `fc_transaction` SET stock_margin_value_1='$currency_avg_rate' WHERE currency_id='$currency_id' AND flag=0 AND txn_order=0 AND txn_group='$txn_group' AND txn_type=2 ");

		$this->db->query(" UPDATE `fc_currency` set currency_avg_rate=$currency_avg_rate 
			where currency_id=".$currency_id." ");

		$this->db->query(" update `fc_main_account` set avg_rate=$currency_avg_rate 
		where currency_id=".$currency_id." ");
	}




	function update_currency_rate($currency_id,$transaction_id,$txn_group){ // check Dashboard ctrl


		/* STRAT update avg rate */
		$main_account_res01=$this->db->query(" SELECT A.currency_id, B.stock_credit,B.stock_debit,B.credit_rm,B.debit_rm,A.rate_unit,B.avg_rate FROM `fc_currency` A LEFT JOIN `fc_main_account` B ON A.currency_id=B.currency_id where A.currency_id=".$currency_id." ");
		$main_account_row01=$main_account_res01->row_array();

		$stock_credit = $main_account_row01['stock_credit'];
		$credit_rm = $main_account_row01['credit_rm'];
		$stock_debit = $main_account_row01['stock_debit'];
		$debit_rm = $main_account_row01['debit_rm'];
		$currrate_unit = ($main_account_row01['rate_unit']>0)?$main_account_row01['rate_unit']:1;
		$current_date = date('Y-m-d');
		$currency_avg_rate_1 = $main_account_row01['avg_rate'];
		$avg_updated = false;
		

		if( $stock_credit == $stock_debit ){
			$avg_rate = 0;
			$this->db->query(" update `fc_main_account` set stock_credit=0, stock_debit=0, credit_rm=0, debit_rm=0 where currency_id=".$this->db->escape($currency_id)." ");
			if($transaction_id>0){
				 $this->db->query(" UPDATE `fc_transaction` SET is_reset=1
				  WHERE transaction_id='$transaction_id' ");
			}
		}

	}

	function txn_group($currency_id){
		$txn_group_query = $this->db->query(" INSERT INTO `fc_txn_group`(currency_id,title)VALUES('$currency_id','1') ");
		$txn_group = $this->db->insert_id();
		return $txn_group;
	}

}
?>