<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Autocomplete extends MY_Controller
{
	function __construct(){
		parent::__construct();
	}
	function index($search=1){
		// search = 1 enable autocomplete
		// search = 0 disable autocomplete
		$record=array();
		$record['filter_name'] = $this->input->get('filter_name');
		$record['user_restrict'] = false;
		$record['search'] = $search;		
		$this->load->model("common_model");
		if( !$this->common_model->verify_user() ){
			$record['user_restrict'] = true;
		}
		$data = $this->common_model->currency_code($record);
		if( $search == 1 ){
			echo json_encode($data);
		}else{
			return $data;
		}
		
	}

	function client_group(){
		$filter_name=$this->input->get('filter_name');
		$data=array();
		$query=$this->db->query(" SELECT * FROM `fc_clients` where client_group like '%$filter_name%' group by client_group ");
		foreach ($query->result_array() as $value) {
			$data[]=$value['client_group'];
		}
		echo json_encode($data);
	}

	function currency_codes(){
		$filter_name=$this->input->get('filter_name');
		$data=array();
	$query=$this->db->query(" SELECT * FROM `fc_currency` where currency_code like '%$filter_name%'");
		foreach ($query->result_array() as $value) {
			$data[]=htmlentities($value['currency_code']);
		}
		echo json_encode($data);
	}


	function client_group_format(){
		$filter_name=$this->input->get('filter_name');
		$this->load->model("common_model");

		$data=array();
		$sql="";
		if( !empty($filter_name) && $filter_name != '' ){
			$sql.=" and client_group like '%$filter_name%' ";
		}

		if( !$this->common_model->verify_user() ){
			$sql.=" and client_id IN ( SELECT id FROM `fc_user_currency_client_group` WHERE atype=0 AND user_id=".$this->session->userdata('fcuser_id')." ) ";
		}

		$query=$this->db->query(" SELECT * FROM `fc_clients` where 1 ".$sql." group by client_group order by client_id limit 10 ");
		foreach ($query->result_array() as $value) {
			$data[]=array(
				'client_id' => $value['client_id'],
				'title' => htmlentities($value['client_group'])
			);
		}
		echo json_encode($data);
	}

	function client_code_format(){
		$filter_name =$this->input->get('filter_name');
		$client_group_id = $this->db->escape($this->input->get('client_group_id'));
		$data=array();
		$sql="";
		if( !empty($filter_name) && $filter_name != '' ){
			$sql=" and client_code like '%$filter_name%' and parent_id=$client_group_id ";
		}
		$query=$this->db->query(" SELECT A.client_id,client_code,A.currency_id FROM `fc_clients` A LEFT JOIN `fc_client_code` B ON A.client_id=B.client_id WHERE 1 ".$sql." limit 10 ");
		foreach ($query->result_array() as $value) {
			$data[]=array(
				'client_id' => $value['client_id'],
				'title' => htmlentities($value['client_code']),
				'client_currency_id' => htmlentities($value['currency_id']),
			);
		}
		echo json_encode($data);
	}

	function client_info($client_id){
		$record = array();
		$this->load->model(array('client_model','currency_model'));
		$result = $this->client_model->show($client_id);
		$currency_res=$this->currency_model->show($result['currency_id']);
		$currency = $currency_res['currency_code'];
		$rate_unit = ($currency_res['rate_unit']>0)?$currency_res['rate_unit']:1;
		$record=array(
			'name'			=> htmlentities($result['name']),
			'client_group'	=> htmlentities($result['client_group']),
			'client_code'	=> htmlentities($result['client_code']),
			'address'		=> htmlentities($result['address']),
			'telephone'		=> htmlentities($result['telephone']),
			'currency'		=> $currency,
			'rate_unit'		=> $rate_unit
		);
		echo json_encode($record);
	}

	function client_by_group($search=1){
		$this->load->model('common_model');
		$record=array();
		$record['client_group_id'] = $this->input->get('cid');
		$record['user_restrict'] = false;
		$data=$this->common_model->client_by_group($record);
		
		if( $search == 1 ){
			echo json_encode($data);
		}else{
			return $data;
		}
		
	}

	function txnids(){
		$filter_name = $this->input->get('filter_name');
		$data=array();
		$query=$this->db->query(" SELECT transaction_id,transaction_reference from fc_transaction where transaction_reference like '%$filter_name%' limit 10 ");
		foreach ($query->result_array() as $value) {
			$data[]=array(
				'transaction_id' => $value['transaction_id'],
				'title'			 => htmlentities($value['transaction_reference'])
			);
		}
		echo json_encode($data);
	}

	function ClientbyGroup(){
		$client_group_id = $this->db->escape($this->input->get('cid'));
		$data=array();
		$sql="";
		if( $client_group_id != '' ){
			$sql.=" and parent_id=$client_group_id ";
		}
		$filter_name= $this->input->get('filter_name');
		$sql.=" and client_code like '%$filter_name%' ";
		
		$query=$this->db->query(" SELECT A.client_id,client_code,A.currency_id FROM `fc_clients` A LEFT JOIN `fc_client_code` B ON A.client_id=B.client_id WHERE 1 ".$sql." ");
		foreach ($query->result_array() as $value) {
			$data[]=array(
				'client_id' => $value['client_id'],
				'title' => htmlentities($value['client_code']),
				'client_currency_id' => htmlentities($value['currency_id']),
			);
		}
		echo json_encode($data);
	}

	function clients(){
		$client_group = array();
		$this->load->model("common_model");
		$filter_name= $this->input->get('filter_name');
		$client_group_sql = '';
		
		if( !$this->common_model->verify_user() ){
			$client_group_sql.=" and B.parent_id IN ( SELECT id FROM `fc_user_currency_client_group` WHERE atype=0 AND user_id=".$this->session->userdata('fcuser_id')." ) ";
		}

		//$query=$this->db->query(" SELECT * FROM `fc_clients` where client_code like '%$filter_name%' ".$client_group_sql." LIMIT 5 ");

		$query=$this->db->query(" SELECT A.client_id,client_code,A.currency_id,A.client_group FROM `fc_clients` A LEFT JOIN `fc_client_code` B ON A.client_id=B.client_id WHERE A.client_code like '%$filter_name%' ".$client_group_sql." limit 10 ");

		foreach ($query->result_array() as $value) {
						
			$client_group[]=array(
				'client_id' => $value['client_id'],
				'title' => htmlentities($value['client_code']),
				'client_currency_id' => htmlentities($value['currency_id']),
				'client_group' => htmlentities($value['client_group']),
			);
		}

		echo json_encode($client_group);
	}
	
	function clientstxn(){
		$client_group = array();
		$this->load->model("common_model");
		$filter_name= $this->input->get('filter_name');
		$client_group_sql = '';
		
		if( !$this->common_model->verify_user() ){
			$client_group_sql.=" and B.parent_id IN ( SELECT id FROM `fc_user_currency_client_group` WHERE atype=0 AND user_id=".$this->session->userdata('fcuser_id')." ) ";
		}

		//$query=$this->db->query(" SELECT * FROM `fc_clients` where client_code like '%$filter_name%' ".$client_group_sql." LIMIT 5 ");

		$query=$this->db->query(" SELECT A.client_id,client_code,A.currency_id,A.client_group, A.name FROM `fc_clients` A LEFT JOIN `fc_client_code` B ON A.client_id=B.client_id WHERE A.client_code like '$filter_name%' ".$client_group_sql." ORDER BY client_code  ");

		foreach ($query->result_array() as $value) {
						
			$client_group[]=array(
				'client_id' => $value['client_id'],
				'title' => htmlentities($value['client_code'].'-'.$value['name']),
				'client_currency_id' => htmlentities($value['currency_id']),
				'client_group' => htmlentities($value['client_group']),
				'clnt_code'	=> $value['client_code']
			);
		}

		echo json_encode($client_group);
	}

	function employee_code(){
		$filter_name=$this->input->get('filter_name');
		$data=array();
		$query=$this->db->query(" SELECT * FROM `fc_employee` where employee_code like '%$filter_name%' ");
		foreach ($query->result_array() as $value) {
			$data[]=array('title' => $value['employee_code'].'-'.$value['employee_name'],'employee_id'=>$value['employee_id']);
		}
		echo json_encode($data);
	}
}
?>