<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Clients extends MY_Controller
{
	function __construct(){
		parent::__construct();
		$this->load->model(array('client_model','common_model','currency_model'));
	}

	function index(){
		$data['page_title']='Clients List';
		$data['message'] = '';
		$csrf = array(
		        'name' => $this->security->get_csrf_token_name(),
		        'hash' => $this->security->get_csrf_hash()
		);
		$data['csrf']=$csrf;
		$data['user_access']=$this->session->userdata('user_access');

		/*update client name*/
		if($this->input->server('REQUEST_METHOD')=='POST' ){
			extract($_POST);
			$is_supplier = isset($is_supplier)?1:0;
			if( $this->input->post('client_name') !='' && $this->input->post('client_id') !='' ) {
				$up = $this->db->query(" update `fc_clients` set name=".strtoupper($this->db->escape($client_name)).", is_supplier='$is_supplier' where client_id=".$this->db->escape($client_id));

				if($up){

					$cinfo = $this->client_model->show($this->input->post('client_id'));
					$tq=$this->db->get_where('fc_transaction', ['client_id'=>$this->input->post('client_id')]);
					$currency = $this->currency_model->show($cinfo['currency_id']);
					$currency_rate_unit = ($currency['rate_unit']>0)?$currency['rate_unit']:1;

					if($cinfo['stock_update_flag'] == 0 && $tq->num_rows() == 0){

						$rm_credit = ($this->input->post('current_bal_rm_type')==1)?$this->input->post('current_bal_rm'):0;
						$rm_credit = str_replace(",","",$rm_credit);

						$rm_debit  = ($this->input->post('current_bal_rm_type')==2)?$this->input->post('current_bal_rm'):0;
						$rm_debit = str_replace(",","",$rm_debit);

						$fc_credit  = ($this->input->post('current_bal_rm_type')==1)?$this->input->post('cfc_balance'):0;
						$fc_credit = str_replace(",","",$fc_credit);

						$fc_debit  = ($this->input->post('current_bal_rm_type')==2)?$this->input->post('cfc_balance'):0;
						$fc_debit = str_replace(",","",$fc_debit);
						$cconvert_rate = ($this->input->post('cconvert_rate')>0)?$this->input->post('cconvert_rate'):1;
						$cfc_balance = str_replace(",","",$this->input->post('cfc_balance'));
						
						if($this->input->post('currency_id') != 1){
							if($this->input->post('current_bal_rm_type')==1){
								$current_bal_rm = $rm_credit = round( (($fc_credit*$cconvert_rate)/$currency_rate_unit),2);
								$current_balance_type = 1;
							}
							if($this->input->post('current_bal_rm_type')==2){
								$current_bal_rm = $rm_debit = round( (($fc_debit*$cconvert_rate)/$currency_rate_unit),2);
								$current_balance_type = 2;
							}
							$fc_rate = round( (1/$cconvert_rate), 10 );
							$fc_convert = $cconvert_rate;
							$fc_total_rate = $cfc_balance;
							$rm_total_rate = $current_bal_rm;
							$quantity = $rm_total_rate;
							$rm_rate = 1;
						}else{
							$current_bal_rm = str_replace(",","",$this->input->post('current_bal_rm'));
							$current_balance_type = $this->input->post('current_bal_rm_type');
							$cfc_balance = $fc_credit = $fc_debit = 0;
							$cconvert_rate = 1;
							$fc_rate=$fc_convert=$fc_total_rate=$fc_total_rate_acc=0;
							$rm_rate = 1;
							$quantity = $rm_total_rate = $current_bal_rm;
						}

					/*
						START transaction
					*/
					$this->db->trans_begin();

						$stock_update_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->post('stock_date'))));
						$this->db->query(" update `fc_clients` set 
							fc_balance 			= '".str_replace(",","",$cfc_balance)."',
							current_balance		= '".$current_bal_rm."',
							conv_rate			= '".str_replace(",","",$cconvert_rate)."',
							stock_update_flag	= '1',
							stock_update_date	= '".$stock_update_date."',
							fc_balance_type		= '".$current_balance_type."',
							current_balance_type	= '".$current_balance_type."'
							where client_id		= ".$this->db->escape($client_id));

						$this->db->query("UPDATE fc_client_account SET 
								fc_credit 	= '".$fc_credit."',
								fc_debit  	= '".$fc_debit."',
								rm_credit	= '".$rm_credit."',
								rm_debit	= '".$rm_debit."'
								where client_id = '".$this->input->post('client_id')."' ");

						$this->db->query(" INSERT INTO `fc_transaction` (`client_id`, `transaction_date`, `txn_type`, `currency_id`, `currency_name`, `currency_rate_unit`,currency_descr, 
							`quantity`,`fc_rate`, `fc_convert`, `rm_rate`, `fc_total_rate`, `rm_total_rate`, `created_at`, `user_id`,`flag`, transaction_reference) VALUES (
							'".$client_id."', 
							'$stock_update_date', 
							'$current_balance_type', '1', 
							'MYR', '1', 'Client Opening Balance',
							'".$quantity."','$fc_rate', '".$fc_convert."', 
							'".$rm_rate."', '".$fc_total_rate."', 
							'".$rm_total_rate."', '".date('Y-m-d H:i:s')."', 
							'".$this->session->userdata('fcuser_id')."', 
							'16', 'OPBAL'); ");

					if ($this->db->trans_status() === FALSE)
					{
					        $this->db->trans_rollback();
					        echo "string12";
					}
					else
					{
					        $this->db->trans_commit();
					}
					/*
						END Transaction
					*/

					}
					else{
						$data['message']=$this->alert->warning('Sorry. Stock may be updated or transactions already exist');
					}

					$data['message']=$this->alert->success('Client Name Updated !!!');
				}else{
					$data['message']=$this->alert->warning('Something went wrong !!!');
				}	
			}
		}

		if( $this->session->userdata('fcadmin_type') == 1 ){
			$data['group_permission'] = TRUE;
		}else{
			$data['group_permission'] = FALSE;
			$data['uclients'] = $this->common_model->client_group_user();
		}
		$group_code_1="";
		if(!empty($this->input->get('group_code_1')) && 
			is_numeric($this->input->get('group_code_1')) ){
			$group_code_1=$this->input->get('group_code_1');
		}
		$data['client_records'] = $this->getlist($group_code_1);
		$data['group_code_1'] = $group_code_1;

		// Client group
		$client_group = array();
		$client_group_sql = '';
		if( !$this->common_model->verify_user() ){
			$client_group_sql.=" and client_id IN ( SELECT id FROM `fc_user_currency_client_group` WHERE atype=0 AND user_id=".$this->session->userdata('fcuser_id')." ) ";
		}
		$query=$this->db->query(" SELECT * FROM `fc_clients` where 1 ".$client_group_sql." group by client_group order by client_id");
		foreach ($query->result_array() as $value) {
						
			$client_group[]=array(
				'client_id' => $value['client_id'],
				'title' => htmlentities($value['client_group'])
			);
		}
		$data['client_groups'] = $client_group;

		$this->load->view('clients',$data);
	}

	function insert(){

		$data = array();
		$data['csrf']=$this->security->get_csrf_hash();
		if($this->input->server('REQUEST_METHOD')=='POST' ){

			if( $this->permission->entry_access(3,$this->session->userdata('fcuser_id')) ){
				$result=$this->client_model->insert();
				if( isset($result['success']) ){

					//$data['message']=$this->alert->success($result['success']);
				
				}elseif( isset($result['danger']) ){

					$data['message']=$this->alert->warning($result['danger']);
				}
			}else{
					$data['message']=$this->alert->warning('Permission Denied !!!');
			}

		}else{

			$data['message']=$this->alert->warning('Permission Denied');	
		
		}
		$data['sequence_no']=$this->common_model->nextAutoID('fc_currency');
		echo  json_encode($data);
	}

	function getlist($group_code_1=''){
		$sno = 0;
		$client_data = array();
		$this->load->model(array("common_model"));

		$parent_sql_1=$parent_sql_2= "";
		if(!empty($group_code_1)){
			$parent_sql_1 = " AND id= ".$this->input->get('group_code_1');
			$parent_sql_2 = " AND parent_id= ".$this->input->get('group_code_1');
		}

		if( !$this->common_model->verify_user() ){
			$cust_group_res = $this->db->query(" SELECT parent_id FROM `fc_client_code`  WHERE parent_id IN ( SELECT id FROM `fc_user_currency_client_group` WHERE atype=0 AND user_id=".$this->session->userdata('fcuser_id')." ".$parent_sql_1." ) GROUP BY parent_id ORDER BY parent_id  ");
		} else {
			$cust_group_res = $this->db->query(" SELECT parent_id FROM `fc_client_code` WHERE 1 ".$parent_sql_2." GROUP BY parent_id ORDER BY parent_id  ");
		}
		
		$this->load->model('user_model');

		foreach ($cust_group_res->result_array() as $cust_group) {
			
			$client_group_code = $this->client_model->show($cust_group['parent_id']);

			if( !$this->common_model->verify_user() ){
				$client_query = $this->db->query(" SELECT * FROM `fc_clients` WHERE client_id IN ( SELECT client_id FROM `fc_client_code` WHERE parent_id IN ( SELECT id FROM `fc_user_currency_client_group` WHERE atype=0 AND user_id=".$this->session->userdata('fcuser_id')." ) )  ");
			} else {
				$client_query = $this->db->query(" SELECT * FROM `fc_clients` WHERE client_id IN ( SELECT client_id FROM `fc_client_code` WHERE parent_id=".$cust_group['parent_id']." )  ");
			}
			
			$client_lists = array();
			foreach ($client_query->result_array() as $result) {

				$currency_arr = $this->currency_model->show($result['currency_id']);
				$currency_name = $currency_arr['currency_code'];

				$account = $this->common_model->client_account($result['client_id'],2);
				$rm_credit=$rm_debit=$fc_credit=$fc_debit=0;
				if($account['rm_balance'] < 0) {
					$rm_credit = $account['rm_balance'];
				}

				if($account['rm_balance'] > 0) {
					$rm_debit = $account['rm_balance'];
				}

				if($account['fc_balance'] < 0) {
					$fc_credit = $account['fc_balance'];
				}

				if($account['fc_balance'] > 0) {
					$fc_debit = $account['fc_balance'];
				}
				if ($result['status'] == 1) {
					$status = '<a href="javascript:;" class="btn btn-sm btn-success update_status" data-client_id="'.$result['client_id'].'">Enabled</a>';
				} else {
					$status = '<a href="javascript:;" class="btn btn-sm btn-danger update_status" data-client_id="'.$result['client_id'].'">Disabled</a>';
				}

				$uinfo = $this->user_model->show($this->session->userdata('fcuser_id'));
				if ($uinfo['client_status'] == 0) {
					$status = '';
				}
				
				
				$client_lists[]=array(
					'client_group'=> '<span class="badge badge-default">'.$result['client_group'].'</span>',
					'client_code'=> '<span class="badge badge-info">'.$result['client_code'].'</span>',
					'currency_name' => '<span class="badge badge-success">'.$currency_name.'</span>',
					'name'		=>	$result['name'],
					'rm_debit'	=>	number_format($rm_debit,2),
					'rm_credit'	=>	number_format($rm_credit,2),
					'fc_debit'	=>	number_format($fc_debit,2),
					'fc_credit'	=>	number_format($fc_credit,2),
					'action'	=>	$status.' <a class="update_record btn btn-primary btn-sm caction" href="javascript:void(0)" data-record_id="'.$result['client_id'].'"><i class="fa fa-edit"></i> ACTION</a>'
				);
			}

			if($client_group_code) {
				$client_data[] = array(
					'client_group_code'	=> 	$client_group_code['client_group'],
					'client_lists'		=>	$client_lists
				);
			}
			
		}

		//print_r($client_data);
		return $client_data;
		
	}

	function view_record($client_id){
		if(isset($client_id)){
			$data['con']=$this->input->get('con');
			$record=$this->client_model->show($client_id);
			$data['result']=$record;
			$qtx = $this->db->get_where('fc_transaction', ['client_id' => $record['client_id']]);
			if($record['stock_update_flag'] == 1 && $qtx->num_rows() > 0){
				$data['stock_update_flag'] = 1;
			}else{
				$data['stock_update_flag'] = 0;
			}

			$currency_arr = $this->currency_model->show($record['currency_id']);
			$data['currency_name'] = $currency_arr['currency_code'];
			//$data['account'] = $this->client_model->client_account($client_id);

			$account = $this->common_model->client_account($client_id,2);
			$rm_credit=$rm_debit=$fc_credit=$fc_debit=0;
			if($account['rm_balance'] < 0) {
				$rm_credit = $account['rm_balance'];
			}

			if($account['rm_balance'] > 0) {
				$rm_debit = $account['rm_balance'];
			}

			if($account['fc_balance'] < 0) {
				$fc_credit = $account['fc_balance'];
			}

			if($account['fc_balance'] > 0) {
				$fc_debit = $account['fc_balance'];
			}

			$data['account'] = array(
									'rm_credit'	=>	$rm_credit,
									'rm_debit'	=>	$rm_debit,
									'fc_credit'	=>	$fc_credit,
									'fc_debit'	=>	$fc_debit
								);

			$csrf = array(
			        'name' => $this->security->get_csrf_token_name(),
			        'hash' => $this->security->get_csrf_hash()
			);
			$data['csrf']=$csrf;
			$this->load->view('ajax/getdata.php',$data);
		}
	}

	function update($client_id){
		if($this->input->server('REQUEST_METHOD')=='POST' ){
			if( $this->permission->modify_access(3,$this->session->userdata('fcuser_id')) ){
				$result=$this->client_model->update($client_id);
				if( isset($result['success']) ){
					$message_status=$this->alert->success($result['success']);
				}elseif( isset($result['danger']) ){
					$message_status=$this->alert->danger($result['danger']);
				}
			}else{
				$message_status=$this->alert->danger('Permission Denied !!!');
			}
			echo $message_status;
		}
	}

	function delete($client_id){
		if($this->input->server('REQUEST_METHOD')=='GET' ){
			$message_status= "";
			if( $this->permission->modify_access(3,$this->session->userdata('fcuser_id')) ){
				$result=$this->client_model->delete($client_id);
				if( isset($result['success']) ){
					$message_status=$this->alert->success($result['success']);
				}elseif( isset($result['danger']) ){
					$message_status=$this->alert->danger($result['danger']);
				}
			}else{
				$message_status=$this->alert->danger('Permission Denied !!!');
			}
			echo $message_status;
		}
	}

	function client_info($client_id){
			$record=$this->client_model->show($client_id);
			$currency_arr = $this->currency_model->show($record['currency_id']);
			$data = array(
						'client_group'	=>	$record['client_group'],
						'currency_name'	=>	$currency_arr['currency_code'],
						'client_name'	=>	$record['name'],
						'address'		=>	$record['address'],
						'opening_balance'=>	$record['opening_balance'],
						'cost'			=>	$record['cost'],
						'is_supplier'	=>	($record['is_supplier']==1)?true:false
					);
			echo json_encode($data);
	}

	function ustatus($client_id)
	{
		if(!is_numeric($client_id)){ die('No Access'); }
		$data = array();

		$query = $this->db->query(" SELECT status FROM `fc_clients` WHERE client_id=".$this->db->escape($client_id)." ");
		$result = $query->row_array();
		$status = ($result['status'] == 1)?'0':'1';
		$up = $this->db->query(" UPDATE fc_clients SET status='$status' WHERE client_id=".$this->db->escape($client_id)." ");
	
		if ($up) {
			$data = array('status' => 'success', 'scode' => $status);
		} else {
			$data = array('status' => 'failed', 'scode' => '');
		}
		echo json_encode($data);
	}

}
?>