<?php  
defined('BASEPATH') OR exit('No direct script access allowed');
class Dashboard extends MY_Controller
{
	function index() {
		$data=array();
		$data['page_title'] = 'Dashboard';
		$this->load->model(array('dashboard_model','currency_model'));

		/* currency stock user based */
		$currencies_list = array();
		$client_group_list = array();
		if( $this->session->userdata('fcadmin_type') != 1 ){
			$curr_array = $this->db->query(" SELECT id AS currency_id FROM `fc_user_currency_client_group` WHERE atype=1 AND user_id=".$this->session->userdata('fcuser_id') );
			if($curr_array->num_rows() > 0) {
				foreach ($curr_array->result_array() as $value) {
					array_push($currencies_list, $value['currency_id']);
				}
			} else {
					array_push($currencies_list, '0');
			}

			$client_array = $this->db->query(" SELECT id AS parent_id FROM `fc_user_currency_client_group` WHERE atype=0 AND user_id=".$this->session->userdata('fcuser_id') );
			if($client_array->num_rows() > 0) {
				foreach ($client_array->result_array() as $clie_value) {
					array_push($client_group_list, $clie_value['parent_id']);
				}
			} else {
					array_push($client_group_list, '0');
			}
			
		}


		$currencies=$this->dashboard_model->currency_list($currency_id=0,$currencies_list);
		$data['currencies']=array();
		foreach ($currencies as $key => $value) {

			$currency_arr = $this->currency_model->show($value['currency_id']);
			$currency_name = $currency_arr['currency_code'].' - '.$currency_arr['description'];

			$data['currencies'][]=array(
				'fc_value'	=> $value['fc_value'],
				'rm_value'	=> $value['rm_value'],
				'margin'  	=> $value['margin'],
				'currency_name' => $currency_name
			);
		}


		$data['myr_value']=array();
		if( in_array('1',$currencies_list) ){
			$data['myr_value']=$this->dashboard_model->rmlist();
		}
		$data['show_recalculate'] = FALSE;
		if( $this->session->userdata('fcadmin_type') == 1 ){
			$data['myr_value']=$this->dashboard_model->rmlist();
			$data['show_recalculate'] = TRUE;
		}

		$data['user_access']=$this->session->userdata('user_access');
		
		$data['client_id']=$client_id=$data['group_code']=""; 
		if( is_numeric($this->input->get('client_id')) ){
		    $data['client_id'] = is_numeric($_GET['client_id'])?$_GET['client_id']:'';
		    $client_id = is_numeric($_GET['client_id'])?$_GET['client_id']:'';
		}
		$group_code='';
		if( is_numeric($this->input->get('group_code')) ){
		    $data['group_code'] = is_numeric($_GET['group_code'])?$_GET['group_code']:'';
		    $group_code = is_numeric($_GET['group_code'])?$_GET['group_code']:'';
		}

		$data['client_accounts']=$this->client_account($client_group_list,$client_id,$group_code);
		
		/* Get client list */
		$client_record=$data['clients']=array();
		$client_record['user_restrict'] = false;
		if( !$this->common_model->verify_user() ){
			$client_record['user_restrict'] = true;
		}
		$clients=$this->common_model->client_by_group($client_record);
		$this->load->model('client_model');
		foreach ($clients as $client) {
			$clrow = $this->client_model->show($client['client_id']);
			$data['clients'][] = array(
						'client_id'	=> $client['client_id'],
						'title'		=> $client['title'].' - '.$clrow['name']
								);
		}

		// Client group
		$client_group = array();
		$client_group_sql = '';
		if( !$this->common_model->verify_user() ){
			$client_group_sql.=" and client_id IN ( SELECT id FROM `fc_user_currency_client_group` WHERE atype=0 AND user_id=".$this->session->userdata('fcuser_id')." ) ";
		}
		$query=$this->db->query(" SELECT * FROM `fc_clients` where 1 ".$client_group_sql." group by client_group order by client_id");
		foreach ($query->result_array() as $value) {
						
			$client_group[]=array(
				'client_id' => $value['client_id'],
				'title' => htmlentities($value['client_group'])
			);
		}
		$data['client_groups'] = $client_group;
		
		$page_number	= (is_numeric($this->uri->segment(3)) && $this->uri->segment(3)>0 )?$this->uri->segment(3):1;
		$total			= count($data['currencies']);
		$page_limit		= 10;
		$total_page		= ceil($total/$page_limit);
		$page_number	= min($page_number, $total_page);
		$offset 		= ($page_number - 1) * $page_limit;
		$data['currencies'] = array_slice($data['currencies'], $offset,$page_limit);
		$data['current_page'] = $page_number;
		$data['total_page']=$total_page;

		// SHOW OPENING BALANCE
		$open_bal_q = $this->db->query("SELECT * FROM `opening_balance`");
		$open_bal_r = $open_bal_q->row_array();
		$data['opening_balance'] = "0.00";
		if($open_bal_q->num_rows() > 0){
			$data['opening_balance'] = number_format($open_bal_r['balance'],2);
		}
		
		$this->load->view('dashboard',$data);
	}

	function db_flush_1(){
		if($this->input->server('REQUEST_METHOD')=='POST' ){
			if( $this->input->post('password') == '123' ){
				//$this->db->query(" TRUNCATE TABLE `fc_client_account` ");
				$this->db->query(" UPDATE fc_client_account SET fc_credit='0',fc_debit='0',rm_credit='0',rm_debit='0' ");
				$this->db->query(" TRUNCATE TABLE `fc_main_account` ");
				$this->db->query(" TRUNCATE TABLE `fc_order` ");
				// $this->db->query(" TRUNCATE TABLE `fc_order_account` ");
				$this->db->query(" TRUNCATE TABLE `fc_settlement` ");
				$this->db->query(" TRUNCATE TABLE `fc_settlement_month` ");
				$this->db->query(" TRUNCATE TABLE `fc_settlement_month_profit` ");
				$this->db->query(" TRUNCATE TABLE `fc_settlement_mtxn` ");
				$this->db->query(" TRUNCATE TABLE `fc_transaction` ");
				$this->db->query(" TRUNCATE TABLE `fc_transaction_settlement` ");
				$this->db->query(" TRUNCATE TABLE `fc_txn_sno` ");
				$this->db->query(" TRUNCATE TABLE `fc_deleted_transaction` ");
				$this->db->query(" TRUNCATE TABLE `fc_txn_group` ");
				$this->db->query(" TRUNCATE TABLE `fc_txn_deleted_group` ");
				$this->db->query(" update `fc_currency` set stock_credit='0', stock_debit='0', credit_rm='0', debit_rm='0', currency_avg_rate='0' ");

				$this->db->query(" UPDATE `fc_clients` SET fc_balance='0', current_balance='0',fc_balance_type='', current_balance_type='',stock_update_date='NULL',stock_update_flag='',conv_rate='' ");

				$this->db->query(" TRUNCATE TABLE `fc_deduction_details` ");
				$this->db->query(" TRUNCATE TABLE `fc_econtribution_details` ");
				$this->db->query(" TRUNCATE TABLE `fc_loan_account` ");
				$this->db->query(" TRUNCATE TABLE `fc_loan` ");
				$this->db->query(" TRUNCATE TABLE `fc_loan_terms` ");
				$this->db->query(" TRUNCATE TABLE `fc_payroll_information` ");
				$this->db->query(" TRUNCATE TABLE `fc_salary` ");
				$this->db->query(" TRUNCATE TABLE `fc_salary_advance` ");
				$this->db->query(" TRUNCATE TABLE `fc_salary_advance_account` ");
				$this->db->query(" TRUNCATE TABLE `fc_salary_basic_pay` ");
				$this->db->query(" TRUNCATE TABLE `fc_salary_deduction` ");
				$this->db->query(" TRUNCATE TABLE `fc_salary_ecdeduction` ");
				$this->db->query(" DELETE FROM `fc_employee` ");
				redirect('dashboard','refresh');
			}else{
				echo '<script> alert("Invalid Password !!!") </script>';
				redirect('dashboard','refresh');
			}
		}


	}

	function client_account($client_group_list,$client_id=0,$group_code=0){
		//print_r($client_group_list);
		$client_group_ids = implode($client_group_list,',');
		$client_sql=$sql="";
		if( $client_id > 0 ) {
			$sql	.=	" AND A.client_id='$client_id' ";
		}

		if( count($client_group_list) > 0 && $group_code == 0){
			$client_sql =" AND parent_id IN (".$client_group_ids.") ";
		}
		if($group_code>0){
			$client_sql =" AND parent_id='$group_code' ";
		}

		$record=array();
		$this->load->model(array('currency_model','common_model','client_model'));
		$code_query = $this->db->query(" SELECT * FROM `fc_client_code` WHERE 1 ".$client_sql." GROUP BY parent_id  ");
		foreach ($code_query->result_array() as $cvalue) {

			
			$query = $this->db->query(" SELECT client_group,client_code,name,ifnull((rm_debit-rm_credit),0) AS rm_balance,ifnull((fc_debit-fc_credit),0) AS fc_balance,A.currency_id FROM `fc_clients` A LEFT JOIN `fc_client_account` B ON A.client_id=B.client_id WHERE A.client_id IN ( SELECT client_id FROM `fc_client_code` WHERE parent_id = '".$cvalue['parent_id']."' ) ".$sql." ORDER BY rm_balance DESC ");


			$results = $query->result_array();		
			$parent = array();	
			foreach ($results as $result) {

				$currency_arr = $this->currency_model->show($result['currency_id']);
				$currency_name = $currency_arr['currency_code'];
				$rm_credit=$rm_debit=$fc_credit=$fc_debit=0;
				if($result['rm_balance'] < 0) {
					$rm_credit = $result['rm_balance'];
				}

				if($result['rm_balance'] > 0) {
					$rm_debit = $result['rm_balance'];
				}

				if($result['fc_balance'] < 0) {
					$fc_credit = $result['fc_balance'];
				}

				if($result['fc_balance'] > 0) {
					$fc_debit = $result['fc_balance'];
				}
				
				$parent[]=array(
						'client_code'	=>	$result['client_code'],
						'name'			=>	$result['name'].' - '.$currency_name,
						'rm_debit'		=>	number_format($rm_debit,2),
						'rm_credit'		=>	number_format($rm_credit,2),
						'fc_debit'		=>	number_format($fc_debit,2),
						'fc_credit'		=>	number_format($fc_credit,2)
				);
			}

			$cres = $this->client_model->show($cvalue['parent_id']);
			if(!empty($cres) && $query->num_rows() > 0 ){
				$record[]=array(
					'group_code' => $cres['client_group'],
					'parent'	 => $parent
				);
			}
		}
		return $record;
	}

function avg_recalculation(){ // check transaction madel
	$message="";
	$success = 0;
	if( $this->session->userdata('fcadmin_type') == 1 ){
		
		$recall_res = $this->db->query(" SELECT transaction_id, currency_id,txn_group,updated_txn_group,id FROM `fc_deleted_transaction` WHERE txn_order=0 AND recalculated=0 AND currency_id!=1 AND flag=0 ");
		$recall_row = $recall_res->row_array();

		$transaction_id 	= $recall_row['transaction_id'];
		$currency_id 		= $recall_row['currency_id'];
		$error_log			= 0;
		$allow_forloop 		= TRUE;
		$txn_group 			= $recall_row['updated_txn_group'];
		$counter = 1; 
		$call_first_method	= FALSE;
		$call_second_method	= FALSE;
		$enable_nex_txnno	= FALSE;
		$error_log_string = "";
		$txnID=array();
		$primaryid = $recall_row['id'];
		$affected_sort = 0;
		$current_txn_group = $recall_row['updated_txn_group'];
		$all_transactionIds = array();
		$all_transactionNos = array();

		$currency_query = $this->db->query(" SELECT currency_avg_rate,currency_code FROM `fc_currency` WHERE `currency_id`='$currency_id'  ");
		$currency_result = $currency_query->row_array();
		$current_currency_avg_rate = $currency_result['currency_avg_rate'];
		$currency_code = $currency_result['currency_code'];

		if( $recall_res->num_rows() > 0 ){	

			$group_exist_query = $this->db->query(" SELECT * FROM `fc_transaction` WHERE 
			txn_order=0 AND currency_id='$currency_id' AND currency_id!=1 AND 
			flag IN (0,1) AND txn_group=$txn_group ORDER BY txnno ASC  ");
			$total_rows  = $group_exist_query->num_rows();
			$total_txns = $group_exist_query->result_array();

			/*
				IF no txn exist in this group then reset the  
			*/
			if($total_rows == 0){
				$this->account_reset($currency_id,$transaction_id);
				$message = 'Stock Average updated. Please Check It !!!';
			}else{

				/*
					Re-update first debit, reset, credit_update,  stock_equivalent
				*/

				$this->db->query(" UPDATE `fc_transaction` SET is_reset=0, is_first_debit=0, credit_update=0, 
				stock_equivalent=0 WHERE txn_order=0 AND currency_id='$currency_id' AND currency_id!=1 AND flag=0 
				AND txn_group='$txn_group' ");
				$total_credit_stock=$total_debit_stock=$currency_stock=0;

				foreach ($total_txns as $value) {

					array_push($all_transactionIds,$value['transaction_id']);
					array_push($all_transactionNos,$value['txnno']);

					/*
						Update the primary id of fc_deleted_transaction and sort order in all rows from the loop
					*/
					++$affected_sort;
					$this->db->query(" UPDATE `fc_transaction` SET affected_row='$primaryid',affected_sort='$affected_sort' WHERE transaction_id='".$value['transaction_id']."' ");

					if($enable_nex_txnno == FALSE){
						$txnno = $value['txnno'];
					}

					if($value['txn_type'] == 1){ //Credit
						$total_credit_stock += $value['quantity'];
						$currency_stock += $value['quantity'];
					}

					if($value['txn_type'] == 2){ //Debit
						$total_debit_stock += $value['quantity'];
						$currency_stock -= $value['quantity'];
					}


					if($total_rows >= $counter){
						if($currency_stock == 0){
							
							array_push($txnID,$value['transaction_id']);

							// Recheck the condition
							if($total_credit_stock < $total_debit_stock){
								$call_second_method	= TRUE;
								$call_first_method	= FALSE;
							}

							if($total_credit_stock >= $total_debit_stock){
								if($call_second_method == FALSE){
									$call_first_method	= TRUE;
									$call_second_method	= FALSE;
								}
							}

							// Update last group average rate based on previous condition that is before reset
							if($call_second_method == TRUE && $call_first_method == FALSE){
								$this->averate_rate_calculate_type_2($currency_id,$txn_group,$txnID);
							}

							if($call_first_method == TRUE && $call_second_method == FALSE){
								$this->averate_rate_calculate_type_1($currency_id,$txn_group,$txnID);
							}

							if( $call_first_method == TRUE && $call_second_method == TRUE ){
								++$error_log;
								$error_log_string .= "Level-1, ";
							}

							if( $call_first_method == FALSE && $call_second_method == FALSE ){
								++$error_log;
								$error_log_string .= "Level-2, ";
							}

							if($error_log == 0){
								// Update reset flag
								$query=$this->db->query(" UPDATE `fc_transaction` SET is_reset='1' WHERE 
								transaction_id='".$value['transaction_id']."' AND flag=0 AND txn_order=0 ");

								// Reset the currency account
								$this->db->query(" UPDATE `fc_main_account` SET stock_credit=0, stock_debit=0, 
								credit_rm=0, debit_rm=0 WHERE currency_id='$currency_id' ");

								$total_credit_stock=$total_debit_stock=$currency_stock=0;
								$txn_group = $this->txn_group($currency_id);
								$call_first_method	= FALSE;
								$call_second_method	= FALSE;
								$txnno = 0;
								$enable_nex_txnno = TRUE;
								$txnID=array();
							}

						}else{

							array_push($txnID,$value['transaction_id']);
							
							// Update txn group and txnno
							$this->db->query(" UPDATE `fc_transaction` SET txnno='$txnno', txn_group='$txn_group' 
							WHERE transaction_id='".$value['transaction_id']."' AND currency_id='$currency_id' 
							AND txn_order=0 AND flag IN (0,1) ");
							
							if($total_credit_stock < $total_debit_stock){
								$call_second_method	= TRUE;
								$call_first_method	= FALSE;
							}

							if($total_credit_stock >= $total_debit_stock){
								if($call_second_method == FALSE){
									$call_first_method	= TRUE;
									$call_second_method	= FALSE;
								}
							}

							if( $total_rows == $counter ){

								if( $call_first_method == TRUE && $call_second_method == TRUE ){
									++$error_log;
									$error_log_string .= "Level-3, ";
								}

								if( $call_first_method == FALSE && $call_second_method == FALSE ){
									++$error_log;
									$error_log_string .= "Level-4, ";
								}

								if($error_log == 0)
								{
									if($call_second_method == TRUE && $call_first_method == FALSE){
										$this->averate_rate_calculate_type_2($currency_id,$txn_group,$txnID);
									}

									if($call_first_method == TRUE && $call_second_method == FALSE){
										$this->averate_rate_calculate_type_1($currency_id,$txn_group,$txnID);
									}
								}

							}

						}

					}else{ //END counter
						++$error_log;
						$error_log_string .= "Level-5, ";
					}

					if($enable_nex_txnno == FALSE){
						$txnno = $value['txnno'];
					}else{
						++$txnno;
					}

				######################### FINAL STAGE ####################################	
				if($total_rows == $counter){

					if($error_log == 0){
						$message = 'Stock Average updated. Please Check It !!!';
						$this->db->query(" UPDATE `fc_deleted_transaction` SET recalculated=1 WHERE transaction_id='$transaction_id' ");
					}else{
						$message = 'Something went wrong. <b>Error Code :</b> '.$error_log_string;

						log_message('error', 'Date:'.date('d-M Y h:i:s').', Error Code : '.$error_log_string.', current_txn_group : '.$current_txn_group.', currency_code : '.$currency_code.'-'.$current_currency_avg_rate.', txnid : '.implode(",",$all_transactionIds));

					}
				}
				######################### END FINAL STAGE ####################################

					++$counter;
				} //END foreach

				

			} //END Row count


		}else{ // if stock already updated
			$message = 'Stock Averages are upto date !!!';
		}

	}else{ // IF user not a super admin
		$message = 'Permission Denied. Please ask admin to re-calculate.';
	}
	echo $message;
}


function averate_rate_calculate_type_1($currency_id,$txn_group,$txnID){
	
	$txnids = implode(',',$txnID);

	$query = $this->db->query(" SELECT txn_type,quantity,rm_total_rate,rm_rate,transaction_id FROM `fc_transaction` WHERE currency_id=$currency_id AND txn_order=0 AND transaction_id IN ($txnids) ORDER BY txnno ASC ");
	$total_stock=$total_rm=0;
	$total_rows = $query->num_rows();

	$currency_query = $this->db->query(" SELECT rate_unit FROM `fc_currency` WHERE currency_id=$currency_id ");
	$currency_result = $currency_query->row_array();
	$currency_rate_unit = $currency_result['rate_unit'];
	$currency_avg_rate = 0;
	foreach ($query->result_array() as $value) {

		if($value['txn_type'] == 1){ //Credit
			$total_stock += $value['quantity'];
			$total_stock = round($total_stock,2);
			$total_rm += $value['rm_total_rate'];
			if( $currency_avg_rate == 0 ){
				$currency_avg_rate = $total_rm/$total_stock;
				$currency_avg_rate = abs($currency_avg_rate*$currency_rate_unit);
			}
		}

		if($value['txn_type'] == 2){ //Debit
			$total_stock -= $value['quantity'];
			$total_stock = round($total_stock,2);
			$original_rm_value = ($value['quantity']*$currency_avg_rate);
			$original_rm_value = ($original_rm_value/$currency_rate_unit);
			$total_rm -= $original_rm_value;
		}

		if( $total_stock > 0 ){
			$currency_avg_rate = $total_rm/$total_stock;
			$currency_avg_rate = abs($currency_avg_rate*$currency_rate_unit);
		}

		if($total_stock == 0){
			$query=$this->db->query(" UPDATE `fc_transaction` SET is_reset='1' WHERE transaction_id='".$value['transaction_id']."' AND flag=0 AND txn_order=0 ");
		}

		$query=$this->db->query(" UPDATE `fc_transaction` SET stock_margin_value_1='$currency_avg_rate' WHERE transaction_id='".$value['transaction_id']."' AND flag=0 AND txn_order=0 AND txn_type=2 ");

		$this->db->query(" UPDATE `fc_currency` set currency_avg_rate=$currency_avg_rate 
		where currency_id=".$currency_id." ");

		$this->db->query(" update `fc_main_account` set avg_rate=$currency_avg_rate 
		where currency_id=".$currency_id." ");
	}
}

function averate_rate_calculate_type_2($currency_id,$txn_group,$txnID){

		$txnids = implode(',',$txnID);

		$query = $this->db->query(" SELECT SUM(quantity) AS quantity, SUM(rm_total_rate) AS rm_total_rate FROM `fc_transaction` WHERE currency_id='$currency_id' AND txn_order=0 AND txn_type=1 
			AND transaction_id IN ($txnids) ");
		$result = $query->row_array();
		$credit_rows = $query->num_rows();

		$currency_query = $this->db->query(" SELECT rate_unit,currency_avg_rate FROM `fc_currency` WHERE currency_id=$currency_id ");
		$currency_result = $currency_query->row_array();
		
		if($credit_rows > 0 && $result['quantity'] > 0){
			$currency_avg_rate = $result['rm_total_rate']/$result['quantity'];
			$currency_avg_rate = abs($currency_avg_rate*$currency_result['rate_unit']);
		}else{
			$currency_avg_rate = $currency_result['currency_avg_rate'];
		}

		$query=$this->db->query(" UPDATE `fc_transaction` SET stock_margin_value_1='$currency_avg_rate' WHERE currency_id='$currency_id' AND flag=0 AND txn_order=0 AND txn_type=2 AND transaction_id IN ($txnids) ");

		$this->db->query(" UPDATE `fc_currency` set currency_avg_rate=$currency_avg_rate 
			where currency_id=".$currency_id." ");

		$this->db->query(" update `fc_main_account` set avg_rate=$currency_avg_rate 
		where currency_id=".$currency_id." ");
}


function txn_group($currency_id){
	$txn_group_query = $this->db->query(" INSERT INTO `fc_txn_group`(currency_id,title)VALUES('$currency_id','1') ");
	$txn_group = $this->db->insert_id();
	return $txn_group;
}
	


	function test_recalculation($currency_id){ // check transaction madel
		$message="";
		$success = 0;
		if( $this->session->userdata('fcadmin_type') == 1 ){	
				//$currency_id=14;
				$rate_average_res = $this->db->query(" SELECT  transaction_id, txn_type, currency_id, quantity, fc_total_rate, rm_total_rate  FROM `fc_transaction` WHERE currency_id='$currency_id' AND txn_order=0 AND flag IN (0,1) ORDER BY
						transaction_id ASC ");

					$results = $rate_average_res->result_array();
					$total_records = $rate_average_res->num_rows();
					
					$stock_credit=$stock_debit=$credit_rm=$debit_rm=0;
					$row_count = 0;

					foreach ($results as $result) {

						$txn_type = $result['txn_type'];
						$quantity = $result['quantity'];
						$fc_total_rate = $result['fc_total_rate'];
						$rm_total_rate = $result['rm_total_rate'];

							++$row_count;
							if( $txn_type == 1 ){
								$stock_credit+=$quantity;
								$credit_rm+=$rm_total_rate;
							}
							if( $txn_type == 2 ){
								$stock_debit+=$quantity;
								$debit_rm+=$rm_total_rate;
							}
							if( $stock_credit == $stock_debit ){

								$this->db->query(" UPDATE `fc_transaction` SET is_reset=1 WHERE transaction_id='".$result['transaction_id']."' AND currency_id='$currency_id' ");

								$stock_credit=$stock_debit=$credit_rm=$debit_rm=0;
							}

							if( $row_count == $total_records ){

								$this->db->query(" UPDATE `fc_main_account` SET stock_credit='$stock_credit', stock_debit='$stock_debit', credit_rm='$credit_rm', debit_rm='$debit_rm' WHERE currency_id='$currency_id' ");

								$this->update_currency_rate($currency_id);

								// $this->db->query(" UPDATE `fc_deleted_transaction` SET recalculated=1 WHERE transaction_id='$transaction_id' ");
								$success = 1;
							}
					}

				if($success==1){
					$message = 'Stock Average updated. Please Check It !!!';
				}else{
					$message = 'Please Try Later !!!';
				}



		}else{
			$message = 'Permission Denied !!!';
		}

		echo $message;

	}

	function account_reset($currency_id,$transaction_id){

	//$this->db->query(" UPDATE `fc_currency` SET currency_avg_rate=0 WHERE currency_id='$currency_id' ");
	$this->db->query(" UPDATE `fc_main_account` SET stock_credit=0, stock_debit=0, credit_rm=0, debit_rm=0 WHERE currency_id='$currency_id' ");

	$this->db->query(" UPDATE `fc_deleted_transaction` SET recalculated=1 WHERE transaction_id='$transaction_id' ");
	}

	function update_currency_rate($currency_id){

		/* STRAT update avg rate */
		$main_account_res01=$this->db->query(" SELECT A.currency_id, B.stock_credit,B.stock_debit,B.credit_rm,B.debit_rm,A.rate_unit,B.avg_rate FROM `fc_currency` A LEFT JOIN `fc_main_account` B ON A.currency_id=B.currency_id where A.currency_id=".$currency_id." ");
		$main_account_row01=$main_account_res01->row_array();

		$stock_credit = $main_account_row01['stock_credit'];
		$credit_rm = $main_account_row01['credit_rm'];
		$stock_debit = $main_account_row01['stock_debit'];
		$debit_rm = $main_account_row01['debit_rm'];
		$currrate_unit = ($main_account_row01['rate_unit']>0)?$main_account_row01['rate_unit']:1;
		$current_date = date('Y-m-d');
		
		if( $stock_credit == $stock_debit ){
			$avg_rate = 0;
			$this->db->query(" update `fc_main_account` set stock_credit=0, stock_debit=0, credit_rm=0, debit_rm=0, avg_rate=0 where currency_id=".$this->db->escape($currency_id)." ");
		}

		if( $stock_credit > 0 || $stock_credit < 0 ){
			$avg_rate = $credit_rm/$stock_credit;
			$avg_rate = abs($avg_rate*$currrate_unit);

			$this->db->query(" update `fc_main_account` set avg_rate=$avg_rate 
			where currency_id=".$this->db->escape($currency_id)." ");
		}

		if( $stock_credit == 0 && ($stock_debit > 0 || $stock_debit < 0) ){
			$avg_rate = $debit_rm/$stock_debit;
			$avg_rate = abs($avg_rate*$currrate_unit);

			$this->db->query(" update `fc_main_account` set avg_rate=$avg_rate 
			where currency_id=".$this->db->escape($currency_id)." ");
		}

		$this->db->query(" UPDATE `fc_currency` set currency_avg_rate=$avg_rate 
			where currency_id=".$currency_id." ");

	}

}
?>