<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Salary extends MY_Controller {

	function __construct(){
		parent::__construct();
		$this->load->model('payroll/salary_model');
		$this->load->helper('sequency');
		if( !$this->permission->entry_access(11,$this->session->userdata('fcuser_id')) ){
        	redirect('dashboard'); die();
        }
	}
	public function index()
	{
		$data['page_title']='Salary Management';
		$data['user_access']=$this->session->userdata('user_access');
		$data['message'] = "";
		$data['heading']  = "Salary Entry Form";

		if( ($this->input->server('REQUEST_METHOD')=='POST') && $this->permission->entry_access(11,$this->session->userdata('fcuser_id')) ){

			extract($_REQUEST);
			$cdate 		= 	date('Y-m-d H:i:s');
			$note 		=	$this->db->escape($note);
			$authorizer =	$this->db->escape($authorizer);
			$receiver 	=	$this->db->escape($receiver);
			$salary_month = $this->input->post('salary_month');
			$employee_id = $this->input->post('employee_id');
			$loan_amount = ($this->input->post('loan_amount') != 0)?$this->input->post('loan_amount'):0;
			$advance_amount = ($this->input->post('advance_amount') != 0)?$this->input->post('advance_amount'):0;
			$net_salary = $this->input->post('net_salary');
			$given_date = date('Y-m-d',strtotime(str_replace('/','-',$given_date)));
			// START FORM VALIDATION
			$log = 0;
			$salinfo=$this->db->query(" SELECT salary_id FROM `fc_salary` where employee_id='$employee_id'
			and salary_month='$salary_month' ");
			if( $salinfo->num_rows() > 0 ){
				$data['message'] = $this->alert->warning('Salary already paid to this employee for this month');
				++$log;
			}

			$salary_advance_res=$this->db->query(" SELECT employee_id FROM `fc_salary_advance_account` 
			where employee_id='$employee_id' AND (credit_amount-debit_amount) < $advance_amount ");
			if( ($salary_advance_res->num_rows() > 0) AND $log == 0 ){
				$data['message'] = $this->alert->warning('Advance amount can not be greater than of balance amount');
				++$log;
			}

			$loan_res=$this->db->query(" SELECT employee_id FROM `fc_loan_account` WHERE employee_id=$employee_id
			HAVING (SUM(credit_amount)-SUM(debit_amount))<$loan_amount  ");
			if( ($loan_res->num_rows() > 0) AND $log == 0 ){
				$data['message'] = $this->alert->warning('Loan amount can not be greater than of balance amount');
				++$log;
			}

			if( $net_salary<0 AND $log == 0 ){ 
				$data['message'] = $this->alert->warning('Salary amount can not be less than of zero');
				++$log;
			}
			// END FORM VALIDATION

			if( $log == 0 ){
				$up=$this->db->query(" INSERT INTO fc_salary SET employee_id='$employee_id',
					salary_month='$salary_month', 
					total_working_days='$total_days', lop_days='$lop',
					authorizer=".$authorizer.", receiver=".$receiver.", note=".$note.", 
					loss_pay_amount='$loss_pay_amount', gross_salary='$gross_salary', 
					total_deduction_amount='$total_deduction_amount', net_salary='$net_salary',
					total_contribution='$total_contribution', created_on='$cdate', 
					updated_on='$cdate',basic_pay='$basic_pay', 
					before_net_salary='$before_net_salary',loan_id='$loan_id', 
					loan_month_yr='$loan_month_yr', loan_amount='$loan_amount',
					advance_amount='$advance_amount', given_date='$given_date', 
					travel_allowance='$travel_allowance', bonus_amount='$bonus_amount',
					user_id=".$this->session->userdata('fcuser_id')." ");
				if($up){
					$salary_id=$this->db->insert_id();
    
				    for( $i=0; $i<count($basic_salary_title); $i++ ){
				      $this->db->query(" INSERT into fc_salary_basic_pay set salary_id='$salary_id', 
				      basic_salary_title='$basic_salary_title[$i]', 
				      bbasic_salary_amount='$bbasic_salary_amount[$i]', 
				      basic_salary_srt='$basic_salary_srt[$i]' ");
				    }

				    for( $i=0; $i<count($deduction_title); $i++ ){
				      $this->db->query(" INSERT into fc_salary_deduction set salary_id='$salary_id', 
				      deduction_title='$deduction_title[$i]', deduction_from='$deduction_from[$i]', 
				      dedpercentage='$dedpercentage[$i]', deduction_amount='$deduction_amount[$i]', 
				      dedsrt='$dedsrt[$i]',`type`='".$ddtype[$i]."' ");
				    }

				    for( $i=0; $i<count($ecdeduction_title); $i++ ){
				      $this->db->query(" INSERT into fc_salary_ecdeduction set salary_id='$salary_id', 
				      ecdeduction_title='$ecdeduction_title[$i]', 
				      ecdeduction_from='$ecdeduction_from[$i]', 
				      ecpercentage='$ecpercentage[$i]', 
				      ecdeduction_amount='$ecdeduction_amount[$i]', ecsort='$ecsort[$i]',
				      `type`='".$ectype[$i]."' ");
				    }

  					$data['message'] = $this->alert->success('Record added successfully');
				}else{
					$data['message'] = $this->alert->warning('Having some problem. Please try later');
				}
			}
		}

		$this->load->view('payroll/salary.php',$data);
	}

	function ajax(){
		$data = array();
		$data['con'] = $this->input->get('con');
		$this->load->model('payroll/employee_model');
		$employee_id = $this->input->get('employee_id');
		$data['employee_info'] = $this->employee_model->get($employee_id);
		$salary_month = $this->input->get('salary_month');
		$data['salary_month'] = $salary_month;
		$lop = 0;
		$salary_month = $salary_month.'-01';
		$total_days = $this->input->get('total_days');

		$salary_info_res=$this->db->query(" SELECT * FROM `fc_payroll_information` where employee_id='".$employee_id."' order by payroll_information_id desc limit 1 ");
		$salary_info_row=$salary_info_res->row_array();
		$payroll_information_id 		= $salary_info_row['payroll_information_id'];
		$basic_salary 					= $salary_info_row['basic'];
		$data['payroll'] 				= array();
		$data['payroll']['basic'] 		= $salary_info_row['basic'];
		$data['payroll']['allowance'] 	= $salary_info_row['allowance'];
		$data['payroll']['hra'] 		= $salary_info_row['hra'];
		$data['payroll']['special_allowance'] = $salary_info_row['special_allowance'];
		$data['payroll']['basic_salary']= $basic_salary;

		$lop=($lop!='' && is_numeric($lop))?$lop:0;
		$total_days = ($total_days!='' && is_numeric($total_days))?$total_days:30;
		$total_days_worked=$total_days-$lop;
		$total_gross = $basic_salary+$salary_info_row['allowance']+$salary_info_row['hra']+$salary_info_row['special_allowance'];
		$data['total_gross'] = $total_gross;
		$data['total_deduction_amount'] = 0;
		$data['total_contribution'] = 0;
		if( $lop>0 ){
		  $per_day_salary 			= $total_gross/$total_days;
		  $loss_pay_amount			= $per_day_salary*$lop;
		  $data['loss_pay_amount'] 	= $loss_pay_amount;
		}
		if( $lop==0 ){
		  $data['loss_pay_amount']  = 0;
		}
		$data['lop'] = $lop;

		$this->load->model('payroll/advance_model');
		$advance_account = $this->advance_model->advance_account($employee_id);
		$data['salary_advance_balance'] = $advance_account['balance_amount'];
		$data['salary_advance_paid']    = $advance_account['debit_amount'];

		$this->load->model('payroll/loan_model');
		$loan_account = $this->loan_model->advance_account($employee_id);
		$data['loan_balance'] = $loan_account['balance_amount'];
		$data['loan_paid']    = $loan_account['debit_amount'];

		$deduction_res = $this->db->query(" SELECT * FROM `fc_deduction_details` 
		where payroll_information_id='$payroll_information_id' and employee_id='$employee_id'
        order by srt  ");
        $data['deductions'] = $deduction_res->result_array();

        $deduction_res=$this->db->query(" SELECT * FROM `fc_econtribution_details` 
        where payroll_information_id='$payroll_information_id' and employee_id='$employee_id'
        order by srt  ");
        $data['econtributions'] = $deduction_res->result_array();

        $loan_res = $this->db->query(" SELECT a.loan_id,b.month_year,b.amout_per_month FROM `fc_loan` a left join fc_loan_terms b on a.loan_id=b.loan_id where b.payment_status=0 and a.status=1 and a.employee_id='$employee_id' ");
        $data['loans'] = $loan_res->result_array();

		$this->load->view('payroll/ajax.php', $data);
	}

	function salary_list(){
		$data = array();
		$data['page_title']='Salary Management';
		$data['user_access']=$this->session->userdata('user_access');
		$data['message'] = "";
		$data['heading']  = "Salary List";
		$this->load->view('payroll/salary_list', $data, FALSE);
	}

	function list_ajax(){
		$records = array();
		$records["data"] = array(); 
		$this->load->model('payroll/employee_model');
		$sql = "";
		if( !empty($this->input->get('from_date')) && !empty($this->input->get('to_date'))  ){
			$from_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('from_date'))));
			$to_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('to_date'))));
			$sql.=" AND given_date between '$from_date' AND '$to_date' ";
		}
		$results = $this->salary_model->records($sql);

		$sno = 0;
		if($results){
			foreach ($results as $result) {
				$emp = $this->employee_model->get($result->employee_id);
				if($result->status == 1){
					$emp_name = '<span class="badge badge-success">'.$emp->employee_code.' - '.$emp->employee_name.'<span>';
				}else{
					$emp_name = '<span class="badge badge-danger">'.$emp->employee_code.' - '.$emp->employee_name.'<span>';
				}

				$records["data"][]=array(
			      ++$sno,
			      $emp_name,
			      '<span class="badge badge-default">'.$result->salary_month.'</span>',
			      '<span class="badge badge-info">'.number_format($result->gross_salary,2).'</span>',
			      '<span class="badge badge-warning">'.number_format($result->net_salary,2).'</span>',
			      date('d-M Y',strtotime($result->created_on)),
			      '<a class="update_record btn btn-primary btn-sm caction" href="javascript:void(0)" data-record_id="'.$result->salary_id.'" data-status="'.$result->status.'" ><i class="fa fa-edit"></i> Action</a>'
			    );
			}
		}
		echo json_encode($records);
	}

	function prints($id){
		if(!is_numeric($id)){ redirect('dashboard','refresh'); }
		$data = array();
		$salary_id = $id;
		$salary_info_res=$this->salary_model->get($salary_id);
		if(!$salary_info_res){ redirect('dashboard','refresh'); }
		$data['salary_info_row'] = $salary_info_res;
		$this->load->model('payroll/employee_model');
		$employee_id = $this->input->get('employee_id');
		$data['employee_info'] = $this->employee_model->get($salary_info_res->employee_id);
		$data['store_info']=$this->salary_model->store();

		$basic_res = $this->db->query(" SELECT * FROM `fc_salary_basic_pay` where salary_id='$salary_id' order by basic_salary_srt ");
		$data['basic_res'] = $basic_res->result_array();

		$deduction_res=$this->db->query(" SELECT * FROM `fc_salary_deduction` where salary_id='$salary_id' order by dedsrt ");
		$data['deduction_res'] = $deduction_res->result_array();

		$ecdeduction_res=$this->db->query(" SELECT * FROM `fc_salary_ecdeduction` where salary_id='$salary_id' order by ecsort ");
		$data['ecdeduction_res'] = $ecdeduction_res->result_array();

		//print_r($data['employee_info']);
		$this->load->view('payroll/salary_slip', $data);
	}

	function delete($id){
		if($this->input->server('REQUEST_METHOD')=='GET' ){
			if( $this->permission->modify_access(11,$this->session->userdata('fcuser_id')) ){
				$result=$this->salary_model->delete($id);
				if( $result ){
					$message_status=$this->alert->success('Record Removed Successfully');
				}else{
					$message_status=$this->alert->danger('Not able to remove the record');
				}
			}else{
					$message_status=$this->alert->danger('Permission Denied !!!');
			}
			echo $message_status;
		}
	}

	function approval($id){
		if(! ($id)){ die(); }
		$data = array();
		$salary_id = $id;
		$query  = $this->db->query(" SELECT * FROM `fc_salary` WHERE salary_id='$salary_id' ");
		$result = $query->row_array();
		$amount = $result['basic_pay'];
		$loan_amount = $result['loan_amount'];
		$advance_amount = $result['advance_amount'];
		$transaction_date = $result['given_date'];
		$travel_allowance = $result['travel_allowance'];
		$bonus_amount = $result['bonus_amount'];
		$salary_flag = 9;
		$advance_flag = 10;
		$loan_flag = 11;
		$bonus_flag=15;
		$allowance_flag=14;
		$cdate = date('Y-m-d H:i:s');
		$salary_seq_type = 7; // for sequence number generation
		$advance_seq_type = 8;
		$allowance_seq_type = 11;
		$bonus_seq_type=12;
		$loan_seq_type = 9;
		$query_status = 1;
		$employee_id = $result['employee_id'];
		$loan_id = $result['loan_id'];
		$loan_month_yr = $result['loan_month_yr'];

		$this->load->model('payroll/employee_model');
		$emp_info = $this->employee_model->get($employee_id);
		$employee_name = htmlspecialchars($emp_info->employee_name);
		$credit_id = $emp_info->credit_id;
		$debit_id  = $emp_info->debit_id;
		$advance_credit_id= $emp_info->sadv_credit_id;
		$advance_debit_id= $emp_info->sadv_debit_id;
		$loan_credit_id= $emp_info->sln_credit_id;
		$loan_debit_id= $emp_info->sln_debit_id;
		$travel_credit_id = $emp_info->travel_credit_id;
		$travel_debit_id = $emp_info->travel_debit_id;
		$bonus_credit_id = $emp_info->bonus_credit_id;
		$bonus_debit_id = $emp_info->bonus_debit_id;
        $txn_sal_count = 0;
		$transaction_info['0'] = array('credit_id' => $credit_id, 'debit_id' => $debit_id, 
			'amount' => $amount, 'flag' => $salary_flag, 'seq_type' => $salary_seq_type, 
			'text'=>'Transaction for salary - '.$employee_name);
		if(abs($amount) > 0 ) { ++$txn_sal_count; }

		$transaction_info['1'] = array('credit_id' => $advance_credit_id, 'debit_id' => $advance_debit_id, 'amount' => $advance_amount, 'flag' => $advance_flag, 'seq_type' => $advance_seq_type, 
			'text' => 'Salary advance - '.$employee_name);
		if(abs($advance_amount) > 0 ) { ++$txn_sal_count; }

		$transaction_info['2'] = array('credit_id' => $loan_credit_id, 'debit_id' => $loan_debit_id, 
			'amount' => $loan_amount, 'flag' => $loan_flag, 'seq_type' => $loan_seq_type, 
			'text' => 'loan - '.$employee_name);
		if(abs($loan_amount) > 0 ) { ++$txn_sal_count; }

		$transaction_info['3'] = array('credit_id' => $travel_credit_id, 'debit_id' => $travel_debit_id, 
			'amount' => $travel_allowance, 'flag' => $allowance_flag, 'seq_type' => $allowance_seq_type, 
			'text' => 'Travel Allowance - '.$employee_name);
		if(abs($travel_allowance) > 0 ) { ++$txn_sal_count; }

		$transaction_info['4'] = array('credit_id' => $bonus_credit_id, 'debit_id' => $bonus_debit_id, 
			'amount' => $bonus_amount, 'flag' => $bonus_flag, 'seq_type' => $bonus_seq_type, 
			'text' => 'Bonus - '.$employee_name);
		if(abs($bonus_amount) > 0 ) { ++$txn_sal_count; }
        $txn_sal_count = $txn_sal_count*2;
		//print_r($transaction_info);

		$client_info = array('credit_id' => $credit_id, 'debit_id' => $debit_id, 'amount' => $amount, 
			'advance_credit_id' => $advance_credit_id, 'advance_debit_id' => $advance_debit_id, 
			'loan_credit_id' => $loan_credit_id, 'loan_debit_id' => $loan_debit_id, 
			'loan_amount' => $loan_amount, 'advance_amount' => $advance_amount, 'travel_credit_id' =>    
			$travel_credit_id, 'travel_debit_id' => $travel_debit_id, 'travel_allowance' => $travel_allowance, 'bonus_credit_id' => $bonus_credit_id, 'bonus_debit_id' => $bonus_debit_id, 
			'bonus_amount' => $bonus_amount );

		/*START VALIDATION*/
		$elog = 0;
		if($result['status'] == 1){ 
			$data=['status'=>'success','message'=>'Payment already approved','refresh'=>0];
			++$elog;
		}
		if( (!is_numeric($credit_id) || $credit_id == 0 || !is_numeric($debit_id) || $debit_id == 0 
			|| $advance_credit_id <= 0 || $advance_debit_id <= 0 || $loan_credit_id <= 0 
		    || $loan_debit_id <= 0 || $travel_credit_id <= 0 || $travel_debit_id <= 0 
		    || $bonus_credit_id <= 0 || $bonus_debit_id <= 0) && $elog == 0 ){
			$data=['status'=>'success','message'=>'Cant find client info','refresh'=>0];
			++$elog;
		}
		if($amount <= 0 && $elog == 0 ){
			$data=['status'=>'success','message'=>'Net Amount must be greater than zero','refresh'=>0];
			++$elog;
		}
		if( ($loan_amount < 0 || $advance_amount < 0) && $elog == 0 ){
			$data=['status'=>'success','message'=>'Amount must be greater than zero','refresh'=>0];
			++$elog;
		}
		$prob_res = $this->db->query(" SELECT salary_id FROM `fc_salary` WHERE txn_status=2 ");
		if($prob_res->num_rows() > 0 && $elog == 0){
			$data=['status'=>'success','message'=>'Problem in last transaction. Please contact admin','refresh'=>0];
			++$elog;
		}

		$chk_client = $this->db->query(" SELECT client_id FROM `fc_clients` WHERE (client_id='$credit_id' OR client_id='$debit_id' OR client_id='$advance_credit_id' OR client_id='$advance_debit_id' OR client_id='$loan_credit_id' OR client_id='$loan_debit_id' OR client_id='$travel_credit_id' 
	 		OR client_id='$travel_debit_id' OR client_id='$bonus_credit_id' OR client_id='$bonus_debit_id' ) AND currency_id !=1  ");
		if($chk_client->num_rows() > 0 && $elog == 0){
			$data=['status'=>'success','message'=>'One Of The Client Account Type is not MYR','refresh'=>0];
			++$elog;
		}
		/*END VALIDATION*/
	
	if($elog == 0)
	{
		if($result['status'] == 0 && $result['txn_status'] == 0){
			
			// To verify that if any flow intruppted. If no intruption then txn_status=1
			$this->db->query(" UPDATE fc_salary SET txn_status=2 WHERE salary_id='$salary_id' ");

			// Salary advance deuction
			if( $advance_amount > 0 ){
			  	$this->db->query(" UPDATE fc_salary_advance_account SET 
			  	debit_amount=debit_amount+$advance_amount WHERE employee_id='$employee_id' ");
			}

			// Loan deduction
			if( $loan_id > 0 && $loan_amount > 0 ){

			  $this->db->query(" UPDATE fc_loan_account SET 
			  debit_amount=debit_amount+$loan_amount WHERE loan_id='$loan_id' 
			  and employee_id='$employee_id' ");

			  $this->db->query(" UPDATE fc_loan_terms SET payment_status=1 WHERE 
			  loan_id='$loan_id' and month_year='$loan_month_yr' and 
			  amout_per_month='$loan_amount' ");
			}


			/* START TRANSACTION AND CLIENT ACCOUNT ENTRY */
		$txn_count = 0;
		for ($i = 0; $i < count($transaction_info) ; $i++) {
		    if(abs($transaction_info[$i]['amount']) > 0) {
			// CREDIT ENTRY
			$txnno_1 = $this->other_sequence_no($transaction_info[$i]['seq_type']);
			$up_1 = $this->db->query(" INSERT INTO `fc_transaction` (`client_id`, `transaction_date`, `txn_type`, `currency_id`, `currency_name`, `currency_rate_unit`,currency_descr, 
				`quantity`, `rm_rate`, `rm_total_rate`, `created_at`, `user_id`,`flag`, 
				other_id, transaction_reference) VALUES ('".$transaction_info[$i]['credit_id']."', 
				'$transaction_date', '1', '1', 
				'MYR', '1', '".$transaction_info[$i]['text']."',
				'".abs($transaction_info[$i]['amount'])."', '1', 
				'".abs($transaction_info[$i]['amount'])."', '".$cdate."', 
				'".$this->session->userdata('fcuser_id')."', 
				'".$transaction_info[$i]['flag']."', '".$salary_id."', 
				'$txnno_1'); ");
			if( $this->db->affected_rows() > 0 ){ 
				++$txn_count; 
			}else{
				++$query_status;
			}	

			// DEBIT ENTRY
			$txnno_2 = $this->other_sequence_no($transaction_info[$i]['seq_type']);
			$up_2 = $this->db->query(" INSERT INTO `fc_transaction` (`client_id`, `transaction_date`, `txn_type`, `currency_id`, `currency_name`, `currency_rate_unit`,currency_descr, 
				`quantity`, `rm_rate`, `rm_total_rate`, `created_at`, `user_id`,`flag`, 
				other_id, transaction_reference) VALUES (
				'".$transaction_info[$i]['debit_id']."', 
				'$transaction_date', '2', '1', 
				'MYR', '1', '".$transaction_info[$i]['text']."',
				'".abs($transaction_info[$i]['amount'])."', '1', 
				'".abs($transaction_info[$i]['amount'])."', '".$cdate."', 
				'".$this->session->userdata('fcuser_id')."', 
				'".$transaction_info[$i]['flag']."', '$salary_id', 
				'$txnno_2'); ");
			if( $this->db->affected_rows() > 0 ){ 
				++$txn_count; 
			}else{
				++$query_status;
			}
		  }
		}

			
		// If all txns are added successfully update client account
		if($query_status == 1 && $txn_count == $txn_sal_count){
		
		$this->client_account_update($client_info);

		$data=['status'=>'success','message'=>'Record has been approved successfully !!!','refresh'=>1];

		$this->db->query(" UPDATE fc_salary SET txn_status=1, status=1, credit_id='$credit_id', 
			debit_id='$debit_id', sadv_credit_id='$advance_credit_id', 
			sadv_debit_id='$advance_debit_id', sln_credit_id='$loan_credit_id', 
			sln_debit_id ='$loan_debit_id', travel_credit_id='$travel_credit_id', travel_debit_id='$travel_debit_id', bonus_credit_id='$bonus_credit_id', bonus_debit_id='$bonus_debit_id' 
			WHERE salary_id='$salary_id' ");

		}else{

			$data=['status'=>'success','message'=>"Some problem occur. Please contact admin.",'refresh'=>0];

			$this->db->query(" UPDATE fc_salary SET txn_status=2 WHERE salary_id='$salary_id' ");
		}

			/* END TRANSACTION AND CLIENT ACCOUNT ENTRY */
			
		}else{
			$data=['status'=>'success','message'=>'Record already approved','refresh'=>0];
		}
	}

		echo json_encode($data);
	}

	function client_account_update($client_info){
		$credit_id 	= $client_info['credit_id'];
		$debit_id 	= $client_info['debit_id'];
		$amount 	= $client_info['amount'];

		$advance_credit_id 	= $client_info['advance_credit_id'];
		$advance_debit_id 	= $client_info['advance_debit_id'];
		$loan_amount 	 	= $client_info['loan_amount'];

		$loan_credit_id 	= $client_info['loan_credit_id'];
		$loan_debit_id 		= $client_info['loan_debit_id'];
		$advance_amount 	= $client_info['advance_amount'];

		$travel_credit_id 	= $client_info['travel_credit_id'];
		$travel_debit_id 	= $client_info['travel_debit_id'];
		$travel_allowance 	= $client_info['travel_allowance'];

		$bonus_credit_id 	= $client_info['bonus_credit_id'];
		$bonus_debit_id 	= $client_info['bonus_debit_id'];
		$bonus_amount 		= $client_info['bonus_amount'];

		
		/* CREDIT ENTRY */
		$this->db->query(" UPDATE fc_client_account SET rm_credit=rm_credit+$amount WHERE 
		client_id=$credit_id ");

		/* DEBIT ENTRY */
		$this->db->query(" UPDATE fc_client_account SET rm_debit=rm_debit+$amount WHERE 
		client_id=$debit_id ");

		/* CREDIT ENTRY */
		$this->db->query(" UPDATE fc_client_account SET rm_credit=rm_credit+$loan_amount WHERE 
		client_id=$advance_credit_id ");

		/* DEBIT ENTRY */
		$this->db->query(" UPDATE fc_client_account SET rm_debit=rm_debit+$loan_amount WHERE 
		client_id=$advance_debit_id ");

		/* CREDIT ENTRY */
		$this->db->query(" UPDATE fc_client_account SET rm_credit=rm_credit+$advance_amount WHERE 
		client_id=$loan_credit_id ");

		/* DEBIT ENTRY */
		$this->db->query(" UPDATE fc_client_account SET rm_debit=rm_debit+$advance_amount WHERE 
		client_id=$loan_debit_id ");

		/* CREDIT ENTRY TRAVEL */
		$this->db->query(" UPDATE fc_client_account SET rm_credit=rm_credit+$travel_allowance WHERE 
		client_id=$travel_credit_id ");

		/* DEBIT ENTRY TRAVEL */
		$this->db->query(" UPDATE fc_client_account SET rm_debit=rm_debit+$travel_allowance WHERE 
		client_id=$travel_debit_id ");

		/* CREDIT ENTRY BONUS */
		$this->db->query(" UPDATE fc_client_account SET rm_credit=rm_credit+$bonus_amount WHERE 
		client_id=$bonus_credit_id ");

		/* DEBIT ENTRY BONUS */
		$this->db->query(" UPDATE fc_client_account SET rm_debit=rm_debit+$bonus_amount WHERE 
		client_id=$bonus_debit_id ");
	}

	function other_sequence_no($otype){
		$this->db->query(" INSERT INTO `fc_txn_other_sno` (`otype`) VALUES ($otype); ");
		$query = $this->db->query(" SELECT id FROM `fc_txn_other_sno` WHERE otype = '$otype' ");
		$nextId = $query->num_rows()+1;
		$sequence_no = other_transaction($nextId,$otype);
		return $sequence_no;
	}

}
?>