<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Order_model extends CI_Model
{
	function insert($sequence_no=''){
		$result=array();
		extract($_POST);
		
		$query01=$this->db->query(" select * from `fc_order` where token=".$this->db->escape($token) );
		if($query01->num_rows()==0){

			$amount=str_replace(",", "", $amount);
			$rate=str_replace(",", "", $rate);
			$rate_unit=str_replace(",", "", $rate_unit);
			$rate_unit = ($rate_unit>0)?$rate_unit:1;
			$total_rm=str_replace(",", "", $total_rm);
			
			$order_date = date('Y-m-d',strtotime( str_replace('/','-',$order_date) ));

			$query=$this->db->query(" INSERT INTO `fc_order` (`token`,`otype`,`currency_id`,`supplier_id`,`user_id`,customer_id,order_date,order_name,name,bank_name,branch_name,acc_number,amount,rate,rate_unit,total_rm,created_on,txn_order_type,sequence_no) VALUES (".$this->db->escape($token).",'1',".$this->db->escape($currency_id).",'".$supplier_id."',".$this->session->userdata('fcuser_id').",".$this->db->escape($customer_id).",".$this->db->escape($order_date).",".$this->db->escape($order_name).",".$this->db->escape($name).",".$this->db->escape($bank_name).",".$this->db->escape($branch_name).",".$this->db->escape($acc_number).",".$this->db->escape($amount).",".$this->db->escape($rate).",".$this->db->escape($rate_unit).",".$total_rm.",'".date('Y-m-d H:i:s')."','1','$sequence_no' ) ");

			
			if($this->db->affected_rows()>0){
				$result['success']='Order added successfully !!!';
			}else{
				$result['danger']='Sorry... Unable to insert the data !!!';
			}

		} else {

			$result['danger']='Sorry... This token already exist !!!';

		}

		return $result;
	}

	function down_record_list($sql){
	    //user_id=".$this->session->userdata('fcuser_id')."
		$query=$this->db->query(" SELECT * FROM (SELECT *, '0' AS dflag FROM `fc_order` UNION ALL SELECT *, '1' AS dflag FROM `fc_order_deleted`) AS A where 1 ".$sql." order by order_id desc ");
		return $query->result_array();
	}
	
	function record_list($sql){
	    //user_id=".$this->session->userdata('fcuser_id')."
		$query=$this->db->query(" SELECT * FROM `fc_order` where 1 ".$sql." order by order_id desc ");
		return $query->result_array();
	}

	function show($order_id){
		$query=$this->db->query(" SELECT * FROM `fc_order` where order_id='$order_id' ");
		return $query->row_array();
	}

	function confirm_order($order_array){
		$order_id=implode(',',$order_array);
		$query = $this->db->query(" SELECT * FROM `fc_order` WHERE order_id IN ($order_id) AND txn_order_type=1 ");
		return $query->result_array();
	}

	function supplier_account($supplier_id,$currency_id){
		// $query=$this->db->query(" SELECT SUM(total_rm) AS stock FROM `fc_order` WHERE supplier_id=$supplier_id  ");
		// return $query->row_array();

		$query = $this->db->query(" 
			SELECT IFNULL(SUM(fc_total_rate),0) AS fc_amount, IFNULL(SUM(rm_total_rate),0) AS rm_amount,'1' AS txn_type FROM `fc_transaction` WHERE client_id='$supplier_id' AND 
			currency_id='$currency_id' AND txn_type=1
			UNION ALL
			SELECT IFNULL(SUM(fc_total_rate),0) AS fc_amount, IFNULL(SUM(rm_total_rate),0) AS rm_amount,'2' AS txn_type FROM `fc_transaction` WHERE client_id='$supplier_id' AND currency_id='$currency_id' AND txn_type=2 
				");

		return $query->result_array();
	}


	function supplier_stock($supplier_id,$currency_id){

		$query = $this->db->query(" 
			
			SELECT IFNULL(SUM(quantity),0) AS quantity, '1' AS txn_type FROM `fc_transaction` 
			WHERE client_id='$supplier_id' AND currency_id='$currency_id' AND txn_type=1

			UNION ALL

			SELECT IFNULL(SUM(amount),0) AS quantity,'2' AS txn_type FROM `fc_order` 
			WHERE supplier_id='$supplier_id' AND currency_id='$currency_id'

				");

		return $query->result_array();
	}

	function currencies(){
		$query=$this->db->query(" SELECT currency_id,currency_code AS title FROM `fc_currency` where currency_id='17' ");
		return $query->result_array();
	}


	function delete($order_id,$delete_type){
		$sql = '';
		if( $delete_type == 1 ){
			$sql = " AND order_id='$order_id' ";
		}

		if( $delete_type == 2 ){
			$sql = " AND order_id IN ($order_id) ";
		}

		$order_query = $this->db->query(" SELECT * FROM `fc_order` where 1 ".$sql." AND txn_order_type=2 ");
		if( $order_query->num_rows() > 0 ){
			$result['danger']='You can not remove this record. Bcz Its moved to transaction';
		}else{
			$query=$this->db->query(" delete FROM `fc_order` where 1 ".$sql);
			if($query){
				$result['success']='Order removed successfully !!!';
			}else{
				$result['danger']='Sorry... Unable to remove !!!';
			}
		}
		
		return $result;
	}


	function supplier_list($record){
		$data=array();
		$sql = "";

		if( $record['user_restrict'] == true ){
			$sql=" and parent_id IN ( SELECT id FROM `fc_user_currency_client_group` WHERE atype=0 AND user_id=".$this->session->userdata('fcuser_id')." ) ";
		}

		$query=$this->db->query(" SELECT A.client_id,client_code,A.currency_id,A.name FROM `fc_clients` A LEFT JOIN `fc_client_code` B ON A.client_id=B.client_id WHERE 1 ".$sql." AND A.is_supplier=1 GROUP BY A.client_id ORDER BY client_code ");
		foreach ($query->result_array() as $value) {
			$data[]=array(
				'client_id' => $value['client_id'],
				'title' => htmlentities($value['client_code'].' - '.$value['name']),
				'client_currency_id' => htmlentities($value['currency_id']),
			);
		}
		return $data;
	}


	// function supplier_account_info($supplier_id){

	// 	$stock = 0;
	// 	$credit_stock = $debit_stock = 0;
	// 	$query = $this->db->query(" SELECT SUM(quantity) AS quantity, txn_type FROM `fc_transaction` WHERE client_id=$supplier_id GROUP BY txn_type ");
	// 	foreach ($query->result_array() as $account_info) {
			
	// 		if($account_info['txn_type'] == 1 ){
	// 			$credit_stock = $account_info['quantity'];
	// 		}

	// 		if($account_info['txn_type'] == 2 ){
	// 			$debit_stock = $account_info['quantity'];
	// 		}

	// 	}

	// 	return $debit_stock - $credit_stock;
	// }
	
	function seq_insert()
	{
	    $this->db->insert('fc_order_seq', array('title' => 'test'));
	}

}
?>